



package charite.christo;
import static charite.christo.ChUtils.*;
import java.io.*;

public final class CBZip2InputStream extends FilterInputStream{
private static int[]_rNums,_crc32Table;
private void updateCRC(int inCh){
if(_crc32Table==null)_crc32Table=intArry(2275);


int temp=(_globalCrc>>24)^inCh;
if(temp<0)temp=256+temp;
_globalCrc=(_globalCrc<<8)^_crc32Table[temp];
}
private int
_tt[],
_globalCrc,
_last,
_origPtr,

_blockSize100k,
_bsBuff,
_bsLive,
_currentChar=-1,
_nInUse,
_currentState=1,_storedBlockCRC,_storedCombinedCRC,_computedBlockCRC,_computedCombinedCRC;
private boolean _blockRandomised;
private int
_su_count,
_su_ch2,
_su_chPrev,
_su_i2,
_su_j2,
_su_rNToGo,
_su_rTPos,
_su_tPos;
private char _su_z;
private byte[]_ll8;
private final boolean[]_inUse=new boolean[256];
private final byte[]_seqToUnseq=new byte[256],_selector=new byte[(2+(900000/50))],_selectorMtf=new byte[(2+(900000/50))],_recvDecodingTables_pos=new byte[6];
private final int[]_unzftab=new int[256],_limit[]=new int[6][258],_base[]=new int[6][258],_perm[]=new int[6][258],_minLens=new int[6],_cftab=new int[257];
private final char[]_yy=new char[256],_temp_charArray2d[]=new char[6][258];
public CBZip2InputStream(InputStream in)throws IOException{
super(in);
_globalCrc=0xffffffff;
if(in.read()!='B'||in.read()!='Z'||in.read()!='h'||(_blockSize100k=in.read()-'0')<1||_blockSize100k>9)throw ioexceptn(9,this);
initBlock();
}
public int read(byte[]dest,int offs,int len)
throws IOException{
if(offs<0||len<0||offs+len>dest.length)throw ioexceptn(14,this);
int destOffs=offs;
for(int HI=offs+len,b;destOffs<HI&&(b=read())>=0;)dest[destOffs++]=(byte)b;
return destOffs==offs?-1:destOffs-offs;
}
public int read()throws IOException{
final int ret=_currentChar;
switch (_currentState){
case 0:return -1;
case 1:
case 2:throw ioexceptn(15,this);
case 3:{
if(_rNums==null) _rNums=intArry(2274);
if(_su_ch2!=_su_chPrev){
_currentState=2;
_su_count=1;
setupPartA(1);
}else if(++_su_count>=4){
_su_z=(char)(_ll8[_su_tPos]&0xff);
_su_tPos=_tt[_su_tPos];
if(_su_rNToGo==0){
_su_rNToGo=_rNums[_su_rTPos]-1;
if(++_su_rTPos==512)_su_rTPos=0;
}else _su_rNToGo--;
_su_j2=0;
_currentState=4;
if(_su_rNToGo==1) _su_z^=1;
setupPartC(1);
}else{
_currentState=2;
setupPartA(1);
}
break;
}
case 4:setupPartC(1);break;
case 5:throw ioexceptn(15,this);
case 6:setupNoRandPartB();break;
case 7:setupPartC(0);break;
default:throw ioexceptn(15,this);
}
return ret;
}
private void initBlock()throws IOException{
final char magic0=((char)bsR(8));
if(magic0==0x17&&((char)bsR(8))==0x72&&((char)bsR(8))==0x45&&((char)bsR(8))==0x38&&((char)bsR(8))==0x50&&((char)bsR(8))==0x90){

_storedCombinedCRC=(((((bsR(8)<<8)|bsR(8))<<8)|bsR(8))<<8)|bsR(8);
_currentState=0;
_ll8=null;
if(_storedCombinedCRC!=_computedCombinedCRC)ioexceptn(16,this);
}else if(magic0!=0x31||((char)bsR(8))!=0x41||((char)bsR(8))!=0x59||((char)bsR(8))!=0x26||((char)bsR(8))!=0x53||((char)bsR(8))!=0x59){
_currentState=0;
throw ioexceptn(10,this);
}else{
_storedBlockCRC=(((((bsR(8)<<8)|bsR(8))<<8)|bsR(8))<<8)|bsR(8);
_blockRandomised=bsR(1)==1;

if(_ll8==null)_ll8=new byte[_blockSize100k*100000];

{
_origPtr=bsR(24);
recvDecodingTables();
final byte[]ll8=_ll8;
final int limitLast=_blockSize100k*100000;


for(int i=256;--i>=0;)_unzftab[_yy[i]=(char)i]=0;
final int eob=_nInUse+1;
int groupNo=0,groupPos=50-1,nextSym=getAndMoveToFrontDecode0(0),bsBuff=_bsBuff,bsLive=_bsLive,last=-1,zt=_selector[groupNo]&0xff;
int[]base_zt=_base[zt],limit_zt=_limit[zt],perm_zt=_perm[zt];
int minLens_zt=_minLens[zt];
while(nextSym!=eob){
if((nextSym==0)||(nextSym==1)){
int s=-1;
for(int n=1;;n<<=1){
if(nextSym==0)s+=n;
else if(nextSym==1)s+=n<<1;
else break;
if(groupPos==0){
groupPos=50-1;
base_zt=_base[zt=_selector[++groupNo]&0xff];
limit_zt=_limit[zt];
perm_zt=_perm[zt];
minLens_zt=_minLens[zt];
}else groupPos--;
int zn=minLens_zt;


while(bsLive<zn){
final int c=in.read();
if(c>=0){
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
continue;
}
throw ioexceptn(13,this);
}
int zvec=(bsBuff>>(bsLive-zn))&((1<<zn)-1);
bsLive-=zn;
while(zvec>limit_zt[zn]){
zn++;
while(bsLive<1){
final int c=in.read();
if(c>=0){
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
continue;
}
throw ioexceptn(13,this);
}
bsLive--;
zvec=(zvec<<1)|((bsBuff>>bsLive)&1);
}
nextSym=perm_zt[zvec-base_zt[zn]];
}
final byte ch=_seqToUnseq[_yy[0]];
_unzftab[ch&0xff]+=s+1;
while(s-->=0)ll8[++last]=ch;
if(last>=limitLast)throw ioexceptn(11,this);
}else{
if(++last>=limitLast)ioexceptn(11,this);
final char tmp=_yy[nextSym-1];
_unzftab[_seqToUnseq[tmp]&0xff]++;
ll8[last]=_seqToUnseq[tmp];
if(nextSym<=16){
for(int j=nextSym-1;j>0;)_yy[j]=_yy[--j];
}else System.arraycopy(_yy,0,_yy,1,nextSym-1);
_yy[0]=tmp;
if(groupPos==0){
groupPos=50-1;
base_zt=_base[zt=_selector[++groupNo]&0xff];
limit_zt=_limit[zt];
perm_zt=_perm[zt];
minLens_zt=_minLens[zt];
}else groupPos--;
int zn=minLens_zt;


while(bsLive<zn){
final int c=in.read();
if(c>=0){
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
continue;
}
throw ioexceptn(13,this);
}
int zvec=(bsBuff>>(bsLive-zn))&((1<<zn)-1);
bsLive-=zn;
while(zvec>limit_zt[zn]){
zn++;
while(bsLive<1){
final int c=in.read();
if(c>=0){
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
continue;
}else throw ioexceptn(13,this);
}
zvec=(zvec<<1)|((bsBuff>>--bsLive)&1);
}
nextSym=perm_zt[zvec-base_zt[zn]];
}
}
_last=last;
_bsLive=bsLive;
_bsBuff=bsBuff;
}
_globalCrc=0xffffffff;
_currentState=1;
}

if(_ll8!=null){
if(_tt==null||_tt.length<_last+1)_tt=new int[_last+1];
_cftab[0]=0;
System.arraycopy(_unzftab,0,_cftab,1,256);
for(int i=1,c=_cftab[0];i<=256;i++)_cftab[i]=(c+=_cftab[i]);
for(int i=0,last=_last;i<=last;i++)_tt[_cftab[_ll8[i]&0xff]++]=i;
if(_origPtr<0||_origPtr>=_tt.length)throw ioexceptn(7,this);
_su_tPos=_tt[_origPtr];
_su_count=_su_i2=0;
_su_ch2=256;
if(_blockRandomised){
_su_rNToGo=_su_rTPos=0;
setupPartA(1);
}else setupPartA(0);
}
}
private int bsR(int n)throws IOException{
int bsLive=_bsLive,bsBuff=_bsBuff;
if(bsLive<n){
do{
final int c=in.read();
if(c<0)throw ioexceptn(13,this);
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
}while(bsLive<n);
_bsBuff=bsBuff;
}
return (bsBuff>>(_bsLive=bsLive-n))&((1<<n)-1);
}
private boolean bsGetBit()throws IOException{
if(_bsLive<1){
final int c=in.read();
if(c<0)throw ioexceptn(13,this);
_bsBuff=(_bsBuff<<8)|c;
_bsLive+=8;
}
return ((_bsBuff>>(--_bsLive))&1)!=0;
}

private static void hbCreateDecodeTables(int[]limit,int[]base,int[]perm,char[]length,int minLen,int maxLen,int alphaSize){
for(int i=minLen,pp=0;i<=maxLen;i++){
for(int j=0;j<alphaSize;j++)if(length[j]==i)perm[pp++]=j;
}
for(int i=23;--i>0;)base[i]=limit[i]=0;
for(int i=0;i<alphaSize;i++)base[length[i]+1]++;
for(int i=1,b=base[0];i<23;i++)base[i]=b+=base[i];
for(int i=minLen,vec=0,b=base[i];i<=maxLen;i++){
final int nb=base[i+1];
limit[i]=(vec+=nb-b)-1;
b=nb;
vec<<=1;
}
for(int i=minLen+1;i<=maxLen;i++)base[i]=((limit[i-1]+1)<<1)-base[i];
}
private void recvDecodingTables()throws IOException{
{
int inUse16=0;

for(int i=0;i<16;i++)if(bsGetBit())inUse16|=1<<i;
for(int i=256;--i>=0;)_inUse[i]=false;
for(int i=0;i<16;i++){
if((inUse16&(1<<i))!=0)for(int j=0;j<16;j++)if(bsGetBit())_inUse[(i<<4)+j]=true;
}
}
{
int nInUse=0;
for(int i=0;i<256;i++)if(_inUse[i])_seqToUnseq[nInUse++]=(byte)i;
_nInUse=nInUse;
}
final int alphaSize=_nInUse+2,nGroups=bsR(3),nSelectors=bsR(15);
for(int i=0;i<nSelectors;i++){
int j=0;
while(bsGetBit())j++;
_selectorMtf[i]=(byte)j;
}

for(int i=nGroups;--i>=0;)_recvDecodingTables_pos[i]=(byte)i;
for(int i=0;i<nSelectors;i++){
int v=_selectorMtf[i]&0xff;
final byte tmp=_recvDecodingTables_pos[v];
while(v>0){

_recvDecodingTables_pos[v]=_recvDecodingTables_pos[v-1];
v--;
}
_selector[i]=_recvDecodingTables_pos[0]=tmp;
}

for(int t=0;t<nGroups;t++){
int curr=bsR(5);
final char[]len_t=_temp_charArray2d[t];
for(int i=0;i<alphaSize;i++){
while(bsGetBit())curr+=bsGetBit()?-1:1;
len_t[i]=(char)curr;
}
}

for(int t=0;t<nGroups;t++){
int minLen=32,maxLen=0;
final char[]len_t=_temp_charArray2d[t];
for(int i=alphaSize;--i>=0;){
final char l=len_t[i];
if(l>maxLen)maxLen=l;
if(l<minLen)minLen=l;
}
hbCreateDecodeTables(_limit[t],_base[t],_perm[t],_temp_charArray2d[t],minLen,maxLen,alphaSize);
_minLens[t]=minLen;
}
}
private int getAndMoveToFrontDecode0(int groupNo)throws IOException{
final int zt=_selector[groupNo]&0xff,limit_zt[]=_limit[zt];
int zn=_minLens[zt],zvec=bsR(zn),bsLive=_bsLive,bsBuff=_bsBuff;
while(zvec>limit_zt[zn]){
zn++;
while(bsLive<1){
final int c=in.read();
if(c>=0){
bsBuff=(bsBuff<<8)|c;
bsLive+=8;
continue;
}
throw ioexceptn(13,this);
}
zvec=(zvec<<1)|((bsBuff>>--bsLive)&1);
}
_bsLive=bsLive;
_bsBuff=bsBuff;
return _perm[zt][zvec-_base[zt][zn]];
}
private void setupPartA(int t)throws IOException{
if(_rNums==null) _rNums=intArry(2274);
if(_su_i2<=_last){
_su_chPrev=_su_ch2;
int su_ch2=_ll8[_su_tPos]&0xff;
if(t==1){
_su_tPos=_tt[_su_tPos];
if(_su_rNToGo==0){
_su_rNToGo=_rNums[_su_rTPos]-1;
if(++_su_rTPos==512)_su_rTPos=0;
}else _su_rNToGo--;
_currentChar=_su_ch2=(su_ch2^=(_su_rNToGo==1)?1:0);
_currentState=3;
}else{
_currentChar=_su_ch2=su_ch2;
_su_tPos=_tt[_su_tPos];
_currentState=6;
}
_su_i2++;
updateCRC(su_ch2);
}else{

_computedBlockCRC=~_globalCrc;

if(_storedBlockCRC!=_computedBlockCRC){


_computedCombinedCRC=((_storedCombinedCRC<<1)|(_storedCombinedCRC>>>31))^_storedBlockCRC;
ioexceptn(16,this);
}
_computedCombinedCRC=((_computedCombinedCRC<<1)|(_computedCombinedCRC>>>31))^_computedBlockCRC;
initBlock();
}
}
private void setupPartC(int t)throws IOException{
if(_su_j2<_su_z){
updateCRC(_currentChar=_su_ch2);
_su_j2++;
if(t==0)_currentState=7;
}else{
if(t==1)_currentState=2;
_su_i2++;
_su_count=0;
setupPartA(t);
}
}
private void setupNoRandPartB()throws IOException{
if(_su_ch2!=_su_chPrev){
_su_count=1;
setupPartA(0);
}else if(++_su_count>=4){
_su_z=(char)(_ll8[_su_tPos]&0xff);
_su_tPos=_tt[_su_tPos];
_su_j2=0;
setupPartC(0);
}else{
setupPartA(0);
}
}
}

