



package charite.christo.strap;
import charite.christo.*;
import static charite.christo.ChUtils.*;
import static java.lang.Math.*;


public final class Matrix3D implements HasMC{
public final static Matrix3D[]NONE={};
private double   _xx=1,_xy,_xz,_xo,_yx,_yy=1,_yz,_yo,_zx,_zy,_zz=1,_zo;


public Matrix3D(){}
public Matrix3D(BA ba){
parseMatrix(ba);
}
public Matrix3D(
double xx,double xy,double xz,double xo,
double yx,double yy,double yz,double yo,
double zx,double zy,double zz,double zo){
_xx=xx;_xy=xy;_xz=xz; _xo=xo;
_yx=yx;_yy=yy;_yz=yz; _yo=yo;
_zx=zx;_zy=zy;_zz=zz; _zo=zo;
}
public Matrix3D(Matrix3D m){
this(m._xx,m._xy,m._xz,m._xo,
m._yx,m._yy,m._yz,m._yo,
m._zx,m._zy,m._zz,m._zo);
}


String[]_chains;
int _assemblyID;





public synchronized Matrix3D scale(double f){
;
_xx*=f;_xy*=f;_xz*=f;_xo*=f;
_yx*=f;_yy*=f;_yz*=f;_yo*=f;
_zx*=f;_zy*=f;_zz*=f;_zo*=f;
_mc++;
return this;
}

public synchronized Matrix3D rotate(char axis,double theta){
final double ct=cos(theta),st=sin(theta);
double
Nxx=_xx,Nxy=_xy,Nxz=_xz,Nxo=_xo,
Nyx=_yx,Nyy=_yy,Nyz=_yz,Nyo=_yo,
Nzx=_zx,Nzy=_zy,Nzz=_zz,Nzo=_zo;
if('x'==axis){
Nyx=_yx*ct + _zx*st;
Nyy=_yy*ct + _zy*st;
Nyz=_yz*ct + _zz*st;
Nyo=_yo*ct + _zo*st;
Nzx=_zx*ct - _yx*st;
Nzy=_zy*ct - _yy*st;
Nzz=_zz*ct - _yz*st;
Nzo=_zo*ct - _yo*st;
}else if('y'==axis){
Nxx=_xx*ct + _zx*st;
Nxy=_xy*ct + _zy*st;
Nxz=_xz*ct + _zz*st;
Nxo=_xo*ct + _zo*st;
Nzx=_zx*ct - _xx*st;
Nzy=_zy*ct - _xy*st;
Nzz=_zz*ct - _xz*st;
Nzo=_zo*ct - _xo*st;
}else if('z'==axis){
Nyx=_yx*ct + _xx*st;
Nyy=_yy*ct + _xy*st;
Nyz=_yz*ct + _xz*st;
Nyo=_yo*ct + _xo*st;
Nxx=_xx*ct - _yx*st;
Nxy=_xy*ct - _yy*st;
Nxz=_xz*ct - _yz*st;
Nxo=_xo*ct - _yo*st;
}
_xx=Nxx; _xy=Nxy; _xz=Nxz;  _xo=Nxo;
_yx=Nyx; _yy=Nyy; _yz=Nyz;  _yo=Nyo;
_zx=Nzx; _zy=Nzy; _zz=Nzz;  _zo=Nzo;
_mc++;
return this;
}


public Matrix3D mult(Matrix3D rhs){
if(rhs==null) return this;
final double
lxx=_xx*rhs._xx + _yx*rhs._xy + _zx*rhs._xz,
lxy=_xy*rhs._xx + _yy*rhs._xy + _zy*rhs._xz,
lxz=_xz*rhs._xx + _yz*rhs._xy + _zz*rhs._xz,
lxo=_xo*rhs._xx + _yo*rhs._xy + _zo*rhs._xz + rhs._xo,
lyx=_xx*rhs._yx + _yx*rhs._yy + _zx*rhs._yz,
lyy=_xy*rhs._yx + _yy*rhs._yy + _zy*rhs._yz,
lyz=_xz*rhs._yx + _yz*rhs._yy + _zz*rhs._yz,
lyo=_xo*rhs._yx + _yo*rhs._yy + _zo*rhs._yz + rhs._yo,
lzx=_xx*rhs._zx + _yx*rhs._zy + _zx*rhs._zz,
lzy=_xy*rhs._zx + _yy*rhs._zy + _zy*rhs._zz,
lzz=_xz*rhs._zx + _yz*rhs._zy + _zz*rhs._zz,
lzo=_xo*rhs._zx + _yo*rhs._zy + _zo*rhs._zz + rhs._zo;
_xx=lxx; _xy=lxy; _xz=lxz; _xo=lxo;
_yx=lyx; _yy=lyy; _yz=lyz; _yo=lyo;
_zx=lzx; _zy=lzy; _zz=lzz; _zo=lzo;
return this;
}
public Matrix3D clone(){
final Matrix3D m=new Matrix3D();
m._xx=_xx; m._xy=_xy; m._xz=_xz; m._xo=_xo; m._yx=_yx; m._yy=_yy; m._yz=_yz; m._yo=_yo; m._zx=_zx; m._zy=_zy; m._zz=_zz; m._zo=_zo;
return m;
}
public synchronized Matrix3D newInverse(){
final Matrix3D m=new Matrix3D();
m._xo=- _xx*_xo-_yx*_yo-_zx*_zo;
m._xx=_xx; m._xy=_yx; m._xz=_zx;
m._yo= -_xy*_xo-_yy*_yo-_zy*_zo;
m._yx=_xy;m._yy=_yy;m._yz=_zy;
m._zo= -_xz*_xo-_yz*_yo-_zz*_zo;
m._zx=_xz;m._zy=_yz;m._zz=_zz;
_mc++;
return m;
}

public synchronized Matrix3D unit(){_xx=_yy=_zz=1;_xo=_yo=_zo=_xy=_xz=_yx=_yz=_zx=_zy=0;  _mc++; return this;}
public synchronized Matrix3D setTranslation(double tx,double ty,double tz){
_xo=tx; _yo=ty; _zo=tz;
_mc++;
return this;
}
public synchronized Matrix3D setTranslation(double[]t) {return setTranslation(t[0],t[1],t[2]);}
public synchronized Matrix3D setRotation(double r[][]){
if(r!=null){
_xx=r[0][0];_xy=r[0][1];_xz=r[0][2];
_yx=r[1][0];_yy=r[1][1];_yz=r[1][2];
_zx=r[2][0];_zy=r[2][1];_zz=r[2][2];
_mc++;
}
return this;
}



public boolean parseMatrixPlain(byte[]T,int b,int e){
return parseMatrixPlain(((ChTokenizer)xvClr(0x100000|336,131)).setText(T,b,e));
}
public boolean parseMatrixPlain(ChTokenizer tok){
final double[]d=new double[12];
for(int i=0;i<12;i++){
if(!tok.nextToken()) return false;
if(Double.isNaN(d[i]=tok.asFloat())) return false;
}
_xx=d[0];
_xy=d[1];
_xz=d[2];
_yx=d[3];
_yy=d[4];
_yz=d[5];
_zx=d[6];
_zy=d[7];
_zz=d[8];
_xo=d[9];
_yo=d[10];
_zo=d[11];
_mc++;
clr(tok);
return true;
}
public boolean parseMatrix(BA ba){
final byte[]T=ba.bytes();
int iRot=-1,iTrans=-1;
for(int iL=0;;iL++){
final int b,e;{final long be=lineTrim(iL,ba);if(be==-1)break;b=(int)(be>>>((long)32));e=(int)(be&0xFFFFffffL);};
if(e>b && T[b]=='-'){
if(e-b>8  && iRot<0   && strEquAt(0,"-ROTATION",T,b,0x7fffffff)) iRot=e;
if(e-b>11 && iTrans<0 && strEquAt(0,"-TRANSLATION",T,b,0x7fffffff)) iTrans=e;
}
if(e>b && T[b]=='<'){
if(e-b>9  && strEquAt(0,"<rotation>",T,b,0x7fffffff)) iRot=b+10;
if(e-b>12 && strEquAt(0,"<translation>",T,b,0x7fffffff)) iTrans=b+13;
}
}
final ChTokenizer tok=((ChTokenizer)xvClr(0x100000|337,131));
if(iRot>0){
tok.setText(T,iRot,ba.end());
tok.nextToken(); _xx=tok.asFloat();
tok.nextToken(); _xy=tok.asFloat();
tok.nextToken(); _xz=tok.asFloat();
tok.nextToken(); _yx=tok.asFloat();
tok.nextToken(); _yy=tok.asFloat();
tok.nextToken(); _yz=tok.asFloat();
tok.nextToken(); _zx=tok.asFloat();
tok.nextToken(); _zy=tok.asFloat();
tok.nextToken(); _zz=tok.asFloat();
}
if(iTrans>0){
tok.setText(T,iTrans,ba.end());
tok.nextToken(); _xo=tok.asFloat();
tok.nextToken(); _yo=tok.asFloat();
tok.nextToken(); _zo=tok.asFloat();
}
clr(tok);
_mc++;
return!isNaN() && iRot>=0 && iTrans>=0;
}



public boolean isUnit(){
return
.9999<_xx && _xx<1.0001  && .9999<_yy && _yy<1.0001 && .9999<_zz && _zz<1.0001&&
-.0001<_xy&&_xy<0.0001&&
-.0001<_xz&&_xz<0.0001&&
-.0001<_yz&&_yz<0.0001&&
-.0001<_xo&&_xo<0.0001&&
-.0001<_yo&&_yo<0.0001&&
-.0001<_zo&&_zo<0.0001;
}

private boolean isNaN(){
return
Double.isNaN(_xx) || Double.isNaN(_xy) || Double.isNaN(_xz)||
Double.isNaN(_yx) || Double.isNaN(_yy) || Double.isNaN(_yz)||
Double.isNaN(_zx) || Double.isNaN(_zy) || Double.isNaN(_zz)||
Double.isNaN(_xo) || Double.isNaN(_yo) || Double.isNaN(_zo);
}



public synchronized float[]transformPoints(float[]v,int from,int to,float[]tv){
final int t=mini(to,v.length/3),t3=t*3,f3=from*3;
if(tv==null) tv=new float[t3-f3];
final float
lxx=(float)_xx,lxy=(float)_xy,lxz=(float)_xz,lxo=(float)_xo,
lyx=(float)_yx,lyy=(float)_yy,lyz=(float)_yz,lyo=(float)_yo,
lzx=(float)_zx,lzy=(float)_zy,lzz=(float)_zz,lzo=(float)_zo;
for(int i=f3,k=0;i<t3; i+=3){
final float x=v[i];
if(Float.isNaN(x)) tv[k++]=tv[k++]=tv[k++]=Float.NaN;
else{
final float y=v[i+1],z=v[i+2];
tv[k++]=x*lxx + y*lxy + z*lxz + lxo;
tv[k++]=x*lyx + y*lyy + z*lyz + lyo;
tv[k++]=x*lzx + y*lzy + z*lzz + lzo;
}
}
return tv;
}

private int _mc=0;
public int mc(){return _mc;}
public boolean equals(Object o){
if(o instanceof Matrix3D){
final Matrix3D m=(Matrix3D)o;
final double D=0.000001;

return
abs(_xx-m._xx)<D&&
abs(_xy-m._xy)<D&&
abs(_xz-m._xz)<D&&
abs(_xo-m._xo)<D&&
abs(_yx-m._yx)<D&&
abs(_yy-m._yy)<D&&
abs(_yz-m._yz)<D&&
abs(_yo-m._yo)<D&&
abs(_zx-m._zx)<D&&
abs(_zy-m._zy)<D&&
abs(_zz-m._zz)<D&&
abs(_zo-m._zo)<D;
}else return false;
}

public int hashCode(){

return(int)(1*100*_xx +  2*100*_xy +  3*100*_xz+
4*100*_yx +  5*100*_yy +  6*100*_yz+
7*100*_zx +  8*100*_zy +  9*100*_zz+
10*100*_xo+ 11*100*_yo + 11*100*_zo);


}

public BA toText(int format,String linePrefix,BA sb){
if(sb==null) sb=new BA(222);
if(format==4){
sb.a("<rotation>\n")
.a(_xx).a('\t').a(_xy).a('\t').a(_xz).a('\n')
.a(_yx).a('\t').a(_yy).a('\t').a(_yz).a('\n')
.a(_zx).a('\t').a(_zy).a('\t').a(_zz).a("\n</rotation>\n<translation>\n")
.a(_xo).a('\t').a(_yo).a('\t').a(_zo).a("\n</translation>\n");

}else if(format==2){
final String pfx=linePrefix!=null?linePrefix:"";
sb
.a(pfx).a("X' = X *").aFloat(_xx,4,3).a(" +  Y *").aFloat(_xy,4,3).a(" +  Z *").aFloat(_xz,4,3).a(" + ").aFloat(_xo,4,3).a('\n')
.a(pfx).a("Y' = Y *").aFloat(_yx,4,3).a(" +  Y *").aFloat(_yy,4,3).a(" +  Z *").aFloat(_yz,4,3).a(" + ").aFloat(_yo,4,3).a('\n')
.a(pfx).a("Z' = Z *").aFloat(_zx,4,3).a(" +  Y *").aFloat(_zy,4,3).a(" +  Z *").aFloat(_zz,4,3).a(" + ").aFloat(_zo,4,3).a('\n');

}else if(format==5){
sb
.aFloat(_xx,4,3).a(' ').aFloat(_xy,4,3).a(' ').aFloat(_xz,4,3).a("  ")
.aFloat(_yx,4,3).a(' ').aFloat(_yy,4,3).a(' ').aFloat(_yz,4,3).a("  ")
.aFloat(_zx,4,3).a(' ').aFloat(_zy,4,3).a(' ').aFloat(_zz,4,3).a("  ")
.aFloat(_xo,4,3).a(' ').aFloat(_yo,4,3).a(' ').aFloat(_zo,4,3);

}else{
final char k=format==3?'|':' ';
sb
.a((float)_xx).a(k).a((float)_xy).a(k).a((float)_xz).a(k)
.a((float)_yx).a(k).a((float)_yy).a(k).a((float)_yz).a(k)
.a((float)_zx).a(k).a((float)_zy).a(k).a((float)_zz).a(k)
.a((float)_xo).a(k).a((float)_yo).a(k).a((float)_zo);
}
return sb;

}
}

