



package charite.christo.strap;
import charite.christo.*;
import java.io.*;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.strap.Strap.*;
import static java.lang.Math.*;

public final class Protein implements HasWRef,ChRunnable{
private final static int[]_tmpFromTo={0,0},TOKEN_FT=new int[88],EXONS_UNABLE_TO_PARSE[]={};
public final static Protein[]NONE={};
private boolean _triedDssp,_revCompl;
private Collection
_vIds,_vRef,_vIdByIdent,
_vComplex,
_vCDS;
private Map

_mapDragfileModi,
_serverMC,

_resnHash;
private int[]_seqDataMC,_resNum,_resNam32,_resAtomNum,_resAtomIdx,_resHasXyz,_resAtomNumOffsets[],_atom32[];
final static int[]AMINOACID_ATOMS[]=new int[(2<<8)+'Z'][],MC_GLOBAL=new int[48];
final static short[][]AMINOACID_ELEMENTS=new short[(2<<8)+'Z'][];
private int _hashCdMC,
_countR,_fromSrc,
_siAminoIdx,_siAtomIdx,_siAtomSerial,
_iFtrCount,
_tokenIdx=-0x80000000,
_ACTGNmc=-1,_actgn,_ntCount=-1,
_subsS=-0x80000000,_subsE,
_xyzByIDtried,
_nameHC,
_vIdByIdentMC;
private long _hashCd,_balloonWhen,_hcXYZ,_iFtr[];
private String
_balloon[],_seqData[],_namePymol,

_balloonDirect,
_name="unnamed",
_accID,
_pdbIds[],
_chainsByType[][],
_chain;
private Object _icon,_icon64,_iconURL,_color;private Object _charSeq;
private byte[]_secStr,_insCode,_cAlphaTxt,_triplets,_pnCDS,_infXYZGapped[];
private byte _infXYZTried;
private float[]_cAlpha,_resAccess,_atomXYZ;


public Protein(){
;
_initAtoms();
}

private final static Object[]HAYSTACKS1=new Object[99];

public synchronized int[]getResidueAtomIdx(){
getAtomXYZ(null);
return _resAtomIdx;
}


public static void oneBox(float[]src,int srcFrom,int srcTo,short[]target,int targetOffset){
final int to6=targetOffset*6,t3=min(srcTo*3,src.length),f3=Math.max(0,srcFrom*3);
if(f3>=t3) return;
for(int i=3;--i>=0;){
float mi=Float.MAX_VALUE,ma=Float.MIN_VALUE;
for(int a3=f3;a3<t3; a3+=3){
final float v=src[a3+i];
if(!(mi<v)) mi=v;
if(!(ma>v)) ma=v;
}
if(mi<-32768+2 || ma>32767-2){
target[to6]=-32768;
break;
}
target[to6+i]=(short)(mi+.5);
target[to6+i+3]=(short)(ma+.5);
}

}
private short[]residueBoundingBox(){
final float[]XYZ=getAtomXYZ();
if(XYZ==null) return null;
final int[]idx=getResidueAtomIdx();
final Object[]cached=cached();
short[]box=(short[])cached[13];
if(setMC(23,mc((10<<6)|18)) || box==null){
final int nR=subsetEnd()-subsetStart();
cached[13]=box=new short[nR*6];
for(int a=0;a<nR;a++){
final int aFL=a+subsetStart(),f=idx.length<=aFL?0:idx[aFL];
if(0<=f) oneBox(XYZ,f,f+getResidueElement(false,a).length,box,a);
}
}
return box;
}
private static float squareDistancePointPoints(boolean yesNo,float x,float y,float z,float[]xyz2,int f2,int t2,float closest2){
for(int i=f2;i<t2; i+=3){
final float d0=xyz2[i]-x;
if(Float.isNaN(d0)) continue;
final float
d1=xyz2[i+1]-y,
d2=xyz2[i+2]-z,
dist2=d0*d0+d1*d1+d2*d2;
if(dist2<closest2){
if(yesNo) return dist2;
closest2=dist2;
}
}
return closest2;
}

private static boolean boundingBoxesFurtherAway(float dist,short[]b1,int i1,short[]b2,int i2){
return
b2[i2]!=-32768&&
b1[i1]!=-32768&&(b2[i2  ]-b1[i1+3]>dist || b1[i1  ]-b2[i2+3]>dist||
b2[i2+1]-b1[i1+4]>dist || b1[i1+1]-b2[i2+4]>dist||
b2[i2+2]-b1[i1+5]>dist || b1[i1+2]-b2[i2+5]>dist);
}

private static boolean pointAndBoundingBoxFurtherAway(float dist,float x,float y,float z,short[]b2,int i2){
return b2[i2]!=-32768 && (
x-b2[i2+3]>dist || b2[i2  ]-x>dist||
y-b2[i2+4]>dist || b2[i2+1]-y>dist||
z-b2[i2+5]>dist || b2[i2+2]-z>dist);
}
public float residueSquareDistanceZ(int opt,int iFrom,int iTo,Object p_or_ressel,float maxDist,boolean[]selected){
final Protein p2=sp(p_or_ressel);
if(p2==null) return Float.NaN;
final boolean cAlpha=INTS[12]==1 && 0!=(opt&(4|(_atomXYZ==null?2:0))) && getResidueCalphaXYZ(null)!=null;
if(cAlpha) maxDist+=5;
final float[]xyz2=p2.getAtomXYZ(),xyz=cAlpha?getResidueCalphaCurrent(): getAtomXYZ();
if(xyz==null||xyz2==null) return Float.NaN;
final int[]ix=cAlpha?null:getResidueAtomIdx(),ix2=p2.getResidueAtomIdx();
final short[]b=cAlpha?null:residueBoundingBox(),b2=p2.residueBoundingBox();
iTo=min(min(iTo,countResidues()),cAlpha?xyz.length/3: min(ix.length,b.length/6));
if((iFrom=max(0,iFrom))>=iTo) return Float.NaN;
final int rsOffset;
final boolean[]rsSelected;
{
final ResidueSelection s=derefRessel(p_or_ressel);
if(s!=null){
rsOffset=s.getSelectedAminoacidsOffset();
rsSelected=s.getSelectedAminoacids();
}else{
rsOffset=0;
rsSelected=null;
}
}
float closest=maxDist,closest2=closest*closest;
boolean ok=false;
final boolean yesNo=0!=(opt&8)||selected!=null;
for(int i2To=min(min(sze(ix2),p2.countResidues()),b2.length/6),i=iFrom,i3=3*i;i<iTo; i++,i3+=3){
int f=0,t=0;
float x=0,y=0,z=0;
if(cAlpha){
if(Float.isNaN(x=xyz[i3])) continue;
y=xyz[i3+1];
z=xyz[i3+2];
}else{
if((f=ix[i]*3)<0)continue;
t=f+3*getResidueElement(false,i).length;
}
for(int j=i2To;--j>=0;){
float newClosest2=closest2;
final int f2=ix2[j]*3;
if(f2<0)continue;
final int t2=f2+3*p2.getResidueElement(false,j).length;
if(rsSelected!=null && !iThBool(j+firstResIdx(p2)-rsOffset,rsSelected)) continue;
if(cAlpha){
if(pointAndBoundingBoxFurtherAway(closest+0.5f,x,y,z,b2,j*6)) continue;
;
newClosest2=squareDistancePointPoints(yesNo,x,y,z,xyz2,f2,t2,newClosest2);
}else{
if(boundingBoxesFurtherAway(closest+1,b,i*6,b2,j*6)) continue;
for(int at=f;at<t; at+=3){
if(!Float.isNaN(x=xyz[at])){
final float dist2=squareDistancePointPoints(yesNo,x,xyz[at+1],xyz[at+2],xyz2,f2,t2,newClosest2);
if(dist2<newClosest2){
newClosest2=dist2;
if(yesNo) break;
}
}
}
}
if(newClosest2<closest2){
if(selected!=null){
if(i<selected.length) selected[i]=true;
break;
}
closest=(float)Math.sqrt(closest2=newClosest2);
if(yesNo) return closest;
ok=true;
}
}
}
return ok?closest:Float.NaN;
}





public String getNameForPymol(){
if(_namePymol==null) _namePymol=new BA(99).aBytesAdj(getResidueName32()[0],4).aInt(resnAt(4,0),4).a('_').a(getChain()).replaceChar(' ','_').toString();
return _namePymol;
}

public BA appendNucColonChain(BA sb){
final int t=INTS[12];
if(t==2||t==3) sb.a(t==2?'D':'R').a("NA:").a(getChain());
else {};
return sb;
}

private void _fromSrc(int opt){
final Object src=getProperty(35);
if(src==null)return;
opt&=~_fromSrc;
_fromSrc|=opt;
if(0!=(opt&(1<<3)) && (_atomXYZ!=null||0==(_flags&16384))) opt&=~(1<<3);
if(0!=(opt&(1<<2)) && deref(_charSeq)!=null) opt&=~(1<<2);
if(opt!=0){

if(looks(4,src,0,0x7fffffff)){
final ProteinParser parser1=(ProteinParser)getProperty(33);
if(xatoi(runCR(721,parser1))==35){
parser1.parse(0,getChain(),readBytes(0!=(opt&(1<<3))?file(addSfx(".XYZ",src)):src),this);
}else{
final BA txt=readBytes(file(src));
final int t=getIntProperty(12);
synchronized(alias(78)){
for(ProteinParser parser:seqParsers())
if(null!=parser.parse(0,null,txt,null))
parser.parse((t==2||t==3?0x2000000:0x1000000),getChain(),txt,this);
}
}
}
}
}





public synchronized boolean containsHeteroCompound(Object h){
return h instanceof Protein && _vv!=null && cntainsEl(h,_vv[6]);
}





public synchronized void setCharSequence(byte[]tt){
strapIncMC(2,this);
_charSeq=tt;
_cache=null;clr(_serverMC);


_ntCount=-1;
}

private File fileSoftRef(){
return(_flags&4)==0 && isTranslated() && getProperty(33)!=null?getFile():null;
}

public synchronized byte[]getCharSequence(){
byte[]seq=(byte[])deref(_charSeq);
if(seq==null)_fromSrc((1<<2));

return seq==null?NO_byte:seq;
}

public synchronized byte[]getResType(){
final byte[]fullLength=getResidueType();
MC[8]=_mcSubset+MC[9];
if(!isSubset()) return fullLength;
final Object[]cached=cached();
byte[]rt=(byte[])cached[5];
if(rt==null) cached[5]=rt=copyOfBytes(fullLength,subsetStart(),subsetEnd());
return rt;
}

public synchronized long getResTypeHC(){
final byte[]bb=getResType();
if(_hashCdMC!=(_hashCdMC=MC[8]) || _hashCd==0) _hashCd=hashCdLUC(bb,0,0x7fffffff);
return _hashCd;
}




public synchronized byte[]getResTypeUC(){
final byte[]aa=getResType();
final int N=countRes();
final Object[]cached=cached();
byte[]AA=(byte[])cached[9];
if(setMC(10,MC[8]) || AA==null || AA.length!=N){
cached[9]=AA=new byte[N];
for(int i=N;--i>=0;) AA[i]=(byte)(aa[i]&~32);
}
return AA;
}
public synchronized String getResTypeSUC(){
final byte[]aa=getResTypeUC();
final Object[]cached=cached();
String AA=(String)cached[10];
if(setMC(11,MC[10]) || AA==null){
cached[10]=AA=s(aa);
}
return AA;
}

public synchronized byte getResTypeAt(int i){
final byte[]aa=getResType();
return 0<=i && i<aa.length && i<countRes()?aa[i]:0;
}

public synchronized void setResidueType(Object seq){
final boolean ok=nxt(0,chrClas(-133),seq,0,0x7fffffff)<0;
setCharSequence(toByts(ok?seq: new BA(0).aFilter(133,seq)));
}

public synchronized int countRes(){
if(INTS[12]==4) return 1;
final byte[]bb=getResType();
final int cr=(bb==null?0:(bb).length);
if(_countR!=cr) {_countR=cr; strapIncMC(47,null);}
return cr;
}
int unsyncResCount(){return _countR;}


public void setChain(String c){
strapIncMC(7,this);
if(sze(c)==0) _chain=null;
else if(!c.equals(_chain)) _chain=toStrgIntrn(c);
}
public String getChain(){return _chain;}

public boolean aSecStru(BA sb){
final byte[]ss=getResidueSecStrType();
if(ss==null) return false;
int L=-1;
for(int i=min(countResidues(),ss.length);--i>=0;){
final byte c=ss[i];
if(c==((byte)' ') || ('a'<=(c|32)&&(c|32)<='z')){
if(L<0 && i<subsetEnd()) L=i+1;
}else{
ss[i]=(byte)'-';
}
}
{

if(L<=subsetStart()) return false;
sb.aFT(ss,subsetStart(),L);
}
return true;
}



public BA resnToIdxInTxt(BA txt){
if(txt==null) return null;
BA sb=null;
final byte[]T=txt.bytes();
final int b=txt.begin(),e=txt.end();
int copiedTo=b;
for(int i=b+1;i<e;i++){
if(T[i]==':'){
final String chain=pdbChainAt(T,i+1,e);
final int chainL=sze(chain),nxt=i+1+chainL;
if(chainL==0 || chain.equals(getChain())){
int d=i-1,nDigits=0,ins=(char)0;
if(('A'<=T[d]&&T[d]<='Z')) ins=T[d--];
if(('A'<=T[d]&&T[d]<='Z')) ins=T[d--];
while(d>=b && ('0'<=T[d]&&T[d]<='9')) {nDigits++;d--;}
if(nDigits>0){
if(!(d>=b && T[d]=='-' && (d==b||!isChrClas(153,T,d-1)))) d++;
if(sb==null) sb=new BA(e-b);
final int resn=((int)atol(T,d,0x7fffffff)),ix=resnToIdx(4,resn,(char)ins);
sb.aFT(T,copiedTo,d);
if(ix<0) sb.a("NaN"); else sb.a(ix+1+getIntProperty(14));
copiedTo=nxt;
}
}
}
}
return sb!=null?sb.aFT(T,copiedTo,e): txt;
}
private static boolean _eqInsCode(int insAtI,int ins){
if(ins==' ') ins='_';
return ins==(char)0 || insAtI==ins || ins=='_' && insAtI==0;
}

public synchronized int resnToIdx(int opt,int resn,char insCode){
final int rn[]=_resNum,subsetStart=subsetStart(),subsetEnd=subsetEnd();
if(insCode<'A') insCode='_';
if(rn==null){
int ia=resn-1-getIntProperty(14);
if(ia<0 || !_eqInsCode(iThByte(ia,_insCode),insCode)||
0==(opt&4) && (ia-=subsetStart)<0) return -1;
return ia;
}
final int L=min(countResidues(),rn.length);
if(0!=(_flags&2048)){
int i=Arrays.binarySearch(rn,0,L,resn);
if(i>=0){
while(i>0 && rn[i-1]==resn) i--;
for(int t=insCode==(char)0&&_insCode!=null?2:1;--t>=0;){
for(;i<L && rn[i]==resn;i++){
if(!_eqInsCode(iThByte(i,_insCode),t>0?'_':insCode)) continue;
if(0!=(opt&4)) return i;
else if(i>=subsetStart && i<subsetEnd) return i-subsetStart;
}
}
}
}else{
final int result=mapResnToI(0,resn,(byte)insCode,0);
if(result==-0x80000000 && insCode==(char)0){
for(int i=L;--i>=0;) if(rn[i]==resn) return i;
}
return result!=-0x80000000?result: -1;
}
return -1;
}
public int indexFromExpression(byte[]T,int f,int t){
if(T==null||f<0) return -1;
if(t>T.length)t=T.length;
final int numE=nxt(256,chrClas(-132),T,chrAt(f,T)=='-'?1+f:f,t);
if(numE==f) return -1;
final int num=((int)atol(T,f,numE)),colon=strchr(':',T,numE,min(t,numE+2));
if(colon<0) return num-1;
final char ins;
if(colon==numE) ins=(char)0;
else if((ins=insCodeChar(chrAt(numE,T)))==0) return num-1;
if(!eqStr(getChain(),pdbChainAt(T,colon+1,t))) return -1;
return resnToIdx(0,num,ins)+firstResIdx(this);
}

public boolean[]residueSubsetAsBool(Object expr,int[]returnMinIdx){
returnMinIdx[0]=0;
if(expr==null) return null;
{
final String otherId;
final int f,t;
synchronized(recordSync(_tmpFromTo,"residueSubsetAsBool")){
otherId=declaredValue("REFERENCE",expr,0,0x7fffffff,_tmpFromTo);
f=_tmpFromTo[0];
t=_tmpFromTo[1];
}
if(otherId!=null){
final Object offset=refSeqOffset(true,otherId);
final BA txt2=new BA(99).aFT(expr,0,f-10).aFT(expr,t,0x7fffffff);
final boolean[]bb;
if(offset instanceof Integer){
bb=residueSubsetAsBool(txt2,returnMinIdx);
returnMinIdx[0]-=xatoi(offset);
}else{
final Protein refP=((ReferenceSequence)offset).refP();
bb=refP==null?NO_boolean:((ReferenceSequence)offset).refIdx2Idx(refP.residueSubsetAsBool(txt2,_tmpFromTo),_tmpFromTo[0],returnMinIdx);
}
return bb;
}
}
final ChTokenizer tok=((ChTokenizer)xvClr(0x100000|338,169)).setText(resnToIdxInTxt(toBA(expr)));
final int maxIdx=countResidues()+firstResIdx(this)+1;
synchronized(alias(73)){
return parseSetGet(returnMinIdx[0]=(int)((parseSet(tok,0,maxIdx))>>32),0x7fffffff);
}
}

public Object refSeqOffset(boolean create,String id){
Map m=_mapRefSeqOffset;
if(id==null || !create&&m==null) return null;
if(m==null) m=_mapRefSeqOffset=new HashMap();
Object offset=m.get(id);
if(offset==null&&create)  m.put(id,offset=new ReferenceSequence(id,this));
return offset;
}
public int resnAt(int opt,int idx){
final int i=idx+(0!=(opt&4)?0:subsetStart());
if(i<0||i>=subsetEnd()) return -0x80000000;
final int[]nn=_resNum;
if(nn!=null&&i<nn.length) if(nn[i]!=-0x80000000) return nn[i];
return i+1;
}

public BA resnAsText(int opt,int i,BA sb){
final byte[]ii=0!=(opt&2)?null:getResidueInsCode();
final int rn=resnAt(opt,i);
if(rn!=-0x80000000){
sb.a(rn);
if(ii!=null){
final char ins=chrAt(i+(0!=(opt&4)?0:subsetStart()),ii);
if(ins!=0) sb.a(ins);
}
if(0==(opt&1))  sb.and(":",getChain());
}
return sb;
}

private int mapResnToI(int mode,int rn,byte ic,int ia){
Map m=_resnHash;
if(_resnHash==null){
_resnHash=m=new HashMap();
final int resn[]=_resNum;
for(int i=resn.length;--i>=0;){
final int n=resn[i];
if(n!=-0x80000000){
mapResnToI(2,n,iThByte(i,_insCode),i);




}
}
}
final Object key=('A'<=ic&&ic<='Z')?longObjct(((long)rn<<8)|insCodeChar(ic)): io(rn);
Object prev=mode==0 || mode==1?m.get(key):null;
if(mode!=0 && prev==null) prev=m.put(key,io(ia));
return prev==null?-0x80000000:xatoi(prev);
}

private byte[]_setUniqueResn(int step,int ia,int[]resn,byte[]insCode){
if(resn[ia]!=-0x80000000) assrt();
int rn=resn[ia-step];
byte ins=iThByte(ia-step,insCode);
while(true){
ins+=step;
if(!('A'<=ins&&ins<='Z')){
rn+=step;
ins=0;
}
if(mapResnToI(1,rn,ins,ia)==-0x80000000){
resn[ia]=rn;
if(('A'<=ins&&ins<='Z')){
if(insCode.length<=ia) insCode=chSze(insCode,ia+20);
insCode[ia]=ins;

}
break;
}
}
return insCode;
}
public synchronized void setResn(int[]resn,byte[]insCode){
_resnHash=null;
if(sze(insCode)>0) _insCode=insCode;
if(resn!=null && resn!=NO_int){
_resNum=resn;
boolean ascending=true;

if(insCode==null) insCode=NO_byte;
for(int i=resn.length-1;--i>=0;) if(resn[i]==-0x80000000 && resn[i+1]!=-0x80000000) insCode=_setUniqueResn(-1,i,resn,insCode);


for(int i=0;i<resn.length;i++){
final int v=resn[i],prev=i==0?-0x80000000:resn[i-1];
if(v==-0x80000000 && prev!=-0x80000000) _setUniqueResn(1,i,resn,insCode);
if(ascending && prev>=v) ascending=false;
}
if(ascending) _flags|=2048;
else _flags&=~2048;
for(int i=sze(insCode);--i>=0;) insCode[i]=(byte)insCodeChar(insCode[i]);
strapIncMC(7,this);
_cache=null;clr(_serverMC);

}
}
public synchronized byte[]getResidueInsCode(){return _insCode;}
public synchronized int[]getResidueName32(){_fromSrc((1<<3)); return _resNam32;}

public synchronized int getResName32At(int i){
final int nR=countRes();
if(i<0||i>=nR) return -0x80000000;
final int name32=iThIntOr(i+subsetStart(),_resNam32,0);
return name32>0?name32:toThreeLetterCode(iThByte(i,getResType()));
}
public boolean resnToSeries(int from,BA sb){
if(_resNum!=null){
final int t=min(subsetEnd(),0x7fffffff);
seriesToTextN(1,_resNum,((((long)(uintToLong(from)))<<32)|(t)),1,0,0,sb);
return true;
}else if(getChain()!=null){
final int n1=resnAt(0,from);
if(n1!=-0x80000000){
if(n1!=1+from){
sb.a("0=").a(n1);
return true;
}
}
}
return false;
}
public boolean toSeries(int what,int from,int to,BA sb){
final byte[]ins=what==1?_insCode: what==2?_secStr:null;
if(nxt(0,chrClas(133),ins,0,0x7fffffff)>=0){
final int f=subsetStart()+from,t=to==0x7fffffff?subsetEnd(): min(subsetEnd(),to-from+f);
seriesToTextC(2|4,ins,((((long)(subsetStart()))<<32)|(t)),sb);
return true;
}
return false;
}





public void setResidueName32(int[]rn) {_resNam32=rn;}





public synchronized int[]getResidueAtomNumber(){
if(_resAtomNum==null) _fromSrc((1<<3));
return _resAtomNum;
}



public float[]getResidueAccessibility1(int opt){
if(opt!=0&&_resAccess==null) _resAccess=getAccessibility(0!=(opt&2),spp(this));
return _resAccess;
}

public synchronized void setResidueSolventAccessibility(float[]a){
strapIncMC(21,this);
_resAccess=a;
_cache=null;clr(_serverMC);
}


public synchronized void setResidueSecStrType(byte[]a){
if(a!=_secStr){
for(int i=sze(a);--i>=0;) if(a[i]==0) a[i]=((byte)' ');
strapIncMC(14,this);
_secStr=a;
}
}

public synchronized byte[]getResidueSecStrType(){
if(_secStr==null && !_triedDssp   && countResidues()>10){
_triedDssp=true;

if(!hasXYZ(this) && getPdbID(((2|4|8|16)|16))!=null) assignSecStru(this);
}
return _secStr;
}



































public static void _initAtoms(){
if(AMINOACID_ELEMENTS[65]!=null)return;
final BA txt=rsc(2354|0x40000000).replaceChar(',','\'');
final ChTokenizer tok=new ChTokenizer(131);
final byte[]T=txt.bytes();
final int eol[]=txt.eol(),buf[]=new int[33];
for(int iL=0;iL<eol.length;iL++){
final int b=iL==0?0:eol[iL-1]+1,eq=strchr('=',T,b,eol[iL]);
if(eq<0)continue;
tok.setText(T,b,eq-1);
int i=0;
while(tok.nextToken()) buf[i++]=tok.asBits();
final int k=((int)atol(T,eq+1,0x7fffffff))+(T[eq-1]=='d'?256:T[eq-1]=='r'?(2<<8):0),aa[]=AMINOACID_ATOMS[k]=copyOfInts(buf,0,i);
final short[]ee=AMINOACID_ELEMENTS[k]=new short[aa.length];
for(int j=ee.length;--j>=0;) ee[j]=(short)(aa[j]&127);
}
}
private short[][]_elements;


public int[]getResidueAtoms32(boolean onlyExplicite,int i){
if(i<0)return null;
int[][]aaa=_atom32;
if(aaa==null){
_fromSrc((1<<3));
if((aaa=_atom32)==null) aaa=_atom32=NO_ints;
}
return i<aaa.length&&aaa[i]!=null?aaa[i]:onlyExplicite?null:iThInts(iThByte(i,getResidueType()),AMINOACID_ATOMS);
}
public short[]getResidueElement(boolean onlyExplicite,int i){
if(i<0)return null;
short[][]eee=_elements;
if(eee==null){
_fromSrc((1<<3));
if((eee=_elements)==null) eee=_elements=NO_shorts;
}
short[]ee=i<eee.length?eee[i]:null;
if(ee==null&&!onlyExplicite)ee=iThShorts(iThByte(i,getResidueType()),AMINOACID_ELEMENTS);
return ee!=null?ee:NO_short;
}
public synchronized int[]getResidueAtomNumberOffsets(int i){
if(i<0)return null;
int[][]eee=_resAtomNumOffsets;
if(eee==null){
_fromSrc((1<<3));
if((eee=_resAtomNumOffsets)==null) eee=_resAtomNumOffsets=NO_ints;
}
return i<eee.length&&eee[i]!=null?eee[i]:null;
}

public String[][]chainsByType(){return _chainsByType;}
public void setAtomSerial(int[]resAtomNum,int[][]resAtomNumOffsets){
_resAtomNum=resAtomNum;
_resAtomNumOffsets=resAtomNumOffsets;
}
public synchronized void setAtoms(float[]xyz,int[]residueAtomIdx,int at32[][],short element[][]){
xyzAddNans(xyz,0,0x7fffffff);
_atomXYZ=xyz;
_resAtomIdx=residueAtomIdx;
_elements=element;
_atom32=at32;
if(xyz==null) _flags&=~16384; else _flags|=16384;
strapIncMC(16,this);
_cache=null;clr(_serverMC);
}
public void setChainsByType(String[][]chainsByType){
if((_chainsByType=chainsByType)!=null) _flags|=16384;
}

public synchronized float[]getAtomXYZ(){return getAtomXYZ(getRotationAndTranslation());}
public synchronized float[]getAtomXYZ(Matrix3D m3d){
_fromSrc((1<<3));
float[]ori=_atomXYZ;
if(ori==null){
if(_infXYZP!=null) _inferXYZ((1<<3));
ori=_atomXYZ;
}
if(ori==null||m3d==null) return ori;
final Object[]cached=cached();
float[]ff=(float[])cached[m3d==_m3d?1:2];
if(setMC(m3d==_m3d?20:17,(m3d==_m3d?MC[18]:0) + MC[16]) || m3d!=_m3d&&_m3dPreview!=m3d || ff==null){
cached[m3d==_m3d?1:2]=ff=redim(ff,ori.length,0);
m3d.transformPoints(ori,0,0x7fffffff,ff);
if(m3d!=_m3d) _m3dPreview=m3d;
}
return ff;
}



public static int _globFlags;
private final Object[]OBJECTS=new Object[39];
public int _flags=64;
private final int[]INTS=new int[18];
{
INTS[0]=INTS[10]=INTS[11]=-1;
INTS[12]=1;
}
public int getRow(){return (_flags&64)==0?-1: INTS[0];}
public void setProperty(int k,Object v){
if(0!=(k&0x80000000) && null!=xiThEl(k,OBJECTS)) return;
k&=0xFFFF;
if(v instanceof String){
if(sze(v)==0) v=null;
else if(chrAt(0,v)=='u' && "unknown".equals(v)) v=null;
else if(0!=(k&0x40000000)){
final String[]ss=(String[])OBJECTS[k];
if(idxOfStrg(0,(String)v,ss)<0) v=adToStrgs((String)v,ss,0);
}
}
if(k==20) v=toStrgArray(0,v);
if(k<8){
OBJECTS[k]=s(v);
}else{
OBJECTS[k]=v;
}
}
public Object getProperty(int k){
Object c=OBJECTS[k];
if(k<8 && c==null){
if(k==2) return OBJECTS[3];
else if(k==4){
final String[]cds=getCDS(INTS[10]);
if(cds!=null) return orS(cds[2],cds[3]);
if(c==null) for(String u:getRefs(1)) if(null!=(c=mapNoClr(223).get(u))) break;
}
}
return c;
}
public void setIntProperty(int k,int v){INTS[k]=v;}
public int getIntProperty(int k){return INTS[k];}

public void setProperty(int key,byte[]T,int b,int e){
if(T==null || 0!=(key&0x80000000) && sze(xiThEl(key,OBJECTS))>0) return;
if(e>T.length) e=T.length;
if(e<b){
if((e=eolTrim(T,b=nxt(0,chrClas(-131),T,b,e),e))>b&&T[e-1]==';')e--;
setProperty(key,key==20 && strchr(',',T,b,e)>=0?
splitTkns(0,T,b,e,chrClas(169)):
s(T,b,e));
}
}

public String getOrganism5(){
final String sc=(String)getProperty(3);
final int spc=strchr('_',sc,0,0x7fffffff);
BA r=null;
if(spc>1 && spc+2<sc.length()){
r=new BA(33);







final int i=idxOfStrg(0x80000,sc,arry(2224));
if(i>=0) r.a(iConst(2225,i));
else r.a(uCaseC(sc.charAt(0))).a(lCaseC(sc.charAt(1))).a(lCaseC(sc.charAt(2))).a(uCaseC(sc.charAt(spc+1))).a(lCaseC(sc.charAt(spc+2)));
}else{
final String sp=seqId(3);
final int us=strchr('_',sp,0,0x7fffffff);
if(us>=0 && sze(sp)-us>5){
r=new BA(33);
for(int i=us+1;i<sp.length();i++) r.a((char)(i==us+1||i==us+4?sp.charAt(i)&~32: sp.charAt(i)|32));
}
}
return s(r);
}

private static int _seqDataNoCache;
private Object _seqData(int i){

switch(i){
case 0:{
String id=seqId(0);
final BA sb=baClr(104);
if(null==id && null==(id=_seqId("UNIPROT",getRefs(1),1)) && null!=(id=seqId(1024|0))) sb.a('=');
if(id!=null) return sb.or(mapNoClr(222).get(id),id).and("+",derefZ(refSeqOffset(false,id),Integer.class));
break;
}
case 1:return seqId(5);
case 2:{
final File f=getFile();
if(f!=null) return dateToStrg(21,f.lastModified());
break;
}
case 3:return dateToStrg(21,_when).substring(5);
case 4:return getName();
case 5:return getProperty(5);
case 6:return getProperty(4);
case 7:return getProperty(2);
case 8:_seqDataNoCache|=(1<<i); return getProperty(3);
case 9:return baClr(158).join(' ',OBJECTS[20]);
case 10:return getPdbID(2);
case 11:return hasCalpha(this)||_infXYZP!=null?"Yes":"No";
case 12:return isTranslated()?"Yes":"No";
case 13:return balloonText(0);
case 14:{
final BA sb=baClr(103);
for(Protein h:getMolecules(4)) if(strstr((4096|8192),h.getName(),sb,0,0x7fffffff)<0) sb.an(' ',sb.end()==0?0:1).a(h);
for(Protein h:getMolecules(7)) h.appendNucColonChain(sb.a(' '));
return sb;
}

case 15:{
final BA sb=baClr(103);
sb.aBytes(' '|(' '<<8)).a(getPdbID(2)).a1(' ').aUnlessInText((4096|8192),seqId(5)).delBlanksR().aln();
for(int k=3;--k>=0;){
sb.aBytes(' '|(' '<<8));
for(String s:k==2?getRefs(0): k==1?getRefs(2):toStrgArray(0,getProperty(20))){
if(!(k==0 && strchr('-',s,0,0x7fffffff)>=0)) sb.aUnlessInText((4096|8192),s).a1(' ');
}
sb.delBlanksR().aln();
}
return sb.aBytes(' '|(' '<<8)).aFile(16,getFile()).delBlanksR();
}
}
return null;
}
public String seqData(int i){
if(0!=(_seqDataNoCache&(1<<i))) return(String)_seqData(i);
if(_seqDataMC==null) {_seqDataMC=new int[16]; _seqData=new String[16];}
final Customize cust=Customize.customize(1700);
if(i<16 && (_seqDataMC[i]!=(_seqDataMC[i]=modic(cust)+MC[6]+MC[8]+MC[4]) || _seqData[i]==null)){
final Object cs=_seqData(i);
String s=null;
if(cs!=null && i<5){
s=toBA(cs).replaceChar('\t',' ').replaceChar('\n',' ').toString().replaceAll("   +","  ");
for(String line:cust.lines()){
if(sze(line)==0 || line.charAt(0)=='#') continue;
final int tab=line.indexOf('\t');
final String pattern=tab<0?line:line.substring(0,tab);
try{
s=s.replaceAll(pattern,toStrgTrim(strplc(0,"%20"," ",tab<0?"":line.substring(tab+1),0,0x7fffffff)));
}catch(Exception ex){baOut("\u001B[45m\u001B[41mWarning\u001B[0m ").a(ex).a(" proteinInfoRplc  pattern=").aln(pattern);}
}
}else{
s=s(cs);
}
_seqData[i]=s;
}
return _seqData[i];
}




private Collection<String>vIdByIdent(boolean create){
if(_vIdByIdentMC!=(_vIdByIdentMC=MC[9])||_vIdByIdent==null){
if(create) _vIdByIdent=new UniqueList(31);
else clr(_vIdByIdent);
}
return _vIdByIdent;
}
public String[]getRefs(int opt){
final Collection v=
opt==1?vIdByIdent(false):
opt==2?_vRef:
_vIds;
return v==null||v.size()==0?NO_String:toStrgArray(0,v);
}
Map _mapRefSeqOffset;



private static String _seqId(String pfx,String[]ss,int dash){
final char c=pfx.charAt(0);
for(String s:ss) if(s.charAt(0)==c&&s.startsWith(pfx) && (dash==0||(s.indexOf('_')>0)==(dash==1))) return s;
return null;
}
public synchronized String seqId(int db){
if(db==5) return _accID;
final String[]rr=getRefs(0);
if(db==3){
String id=_seqId("UNIPROT",rr,1);
if(id==null){
for(String u:getRefs(1)){
if(null!=(id=(String)mapNoClr(222).get(u))) return id;
}
}
return id;
}else{
String id=null,pfx=iConst(1924,db&255);
if(0==(db&1024)){
if((db&255)==0) id=_seqId(pfx,rr,-1);
if(id==null) id=_seqId(pfx,rr,0);
}
if(id==null && 0!=(db&(512|1024))) id=_seqId(pfx,getRefs(1),0);
return id;
}
}
public String getPdbID(int bits){
if(_pdbIds!=null){
final int B=bits!=0?bits:2;
for(int i=0;i<_pdbIds.length;i++){
if((B&(1<<i))!=0){
final String id=_pdbIds[i];
if(id!=null && (bits&64)==0||pdbChain(id)!=null) return id;
}
}
}
return null;
}
public boolean setPdbID(int opt,String id){
if(sze(id)==0) id=null; else id=addPfx("PDB:",id);
final int log2;
{
final int bits=opt&(32-1);
for(Protein h:getMolecules(6))  h.setPdbID(opt,id);
if(0!=(opt&128) && getPdbID(2)!=null) return false;
log2=bits==0?0: log2(bits);
}
if(_pdbIds==null) _pdbIds=new String[32-1];
final boolean changed=!eq(id,_pdbIds[log2]);
_pdbIds[log2]=id;
if(log2==0) addSeqRef(0x40000000,id);
_xyzByIDtried=0;
return changed;
}
public synchronized boolean hasPdbId(String s){
return s!=null && strEquAt(0x80000,pdbID(s),getPdbID(2),4,0x7fffffff) && eqStr(getChain(),pdbChain(s));
}
public synchronized void removeSequenceRef(String s){
if(sze(s)>0){
if("*".equals(s)) clr(_vIds);
else{
rmElmntFromV(s,_vIds);
if(s.equals(_accID)) _accID=null;
setToNull(true,s,_pdbIds);
}
}
}

public synchronized String addSeqRef(int opt,String s){
if(sze(s)==0) return null;
int offset=opt&0xffFFFF;
{
final int exclam=s.indexOf('!');
if(exclam>0){
offset=((int)atol(s,exclam+1,0x7fffffff));
s=s.substring(0,exclam);
}
}
if((s=canonicalSeqidColonDB(s))==null) return null;
{
final int colon=s.indexOf(':');
if(s.length()==colon+1) return null;
if(colon<0) {
final String db=guessDbFromId(onlyActgn(),s);
if(sze(db)>0) s=addPfx(db,s);
}
}
if(0!=(opt&0x80000000)){
if(idxOfStrg(0,s,getRefs(0))>=0) return s;
if(vIdByIdent(true).add(s)) strapIncMC(4,this);
baLog(85).a(this).a(' ').a(s).a('+').a(offset).aln();
}else{
if(s.startsWith("PDB:")) setPdbID(2|128,s);
if(_vIds==null) _vIds=new UniqueList(31);
if(0!=(opt&0x40000000)){
if(!s.equals(xiThEl(0,_vRef))){
_vIds.remove(s);
((List)_vIds).add(0,_accID=s);
strapIncMC(4,this);
}
}else if(_vIds.add(s)) strapIncMC(4,this);
}
;
if(offset>0){
if(_mapRefSeqOffset==null) _mapRefSeqOffset=new HashMap();
_mapRefSeqOffset.put(s,io(offset));
}
return s;
}
public synchronized void addDatabaseRef(String s){
if(s!=null && (_vRef==null?_vRef=new UniqueList(31): _vRef).add(s)) strapIncMC(4,this);
}



public void setName(Object name){
final String n=delIdx(0x80000|0x1000000|'/',toStrgN(name).trim());
if(!n.equals(_name)){
_name=n;
_nameHC=0;
if(OBJECTS[24]==null) OBJECTS[24]=n;
strapIncMC(6,this);

final int exclam=n.indexOf('!');
if(exclam>0) setSubset(n.substring(exclam+1));
}
}
public synchronized int getNameHC(){
if(_nameHC==0) _nameHC=getName().hashCode();
return _nameHC;
}
public String getName(){return _name;}
public String toString(){return getName();}



private File _fBalloon, _f;
public File getFile(){return _f;}
long _hashCdTxt;
public synchronized void setFile(File f){
_f=f;
if(getName()=="unnamed" && f!=null) setName(f.getName());

MC[1]=0;
if(f!=null){
mapNoClr(0x70000|211).put(f,io(1708));
INTS[13]=(OBJECTS[22]=f.getName()).hashCode();
}else{
OBJECTS[22]=null;
INTS[13]=0;
}
strapIncMC(6,this);

}

public float[]xyzByID(boolean sideChain){
float[]xyz=sideChain?getAtomXYZ(): getResidueCalphaCurrent();

if(xyz==null && 0==(_xyzByIDtried&(sideChain?1:2))){
_xyzByIDtried|=(sideChain?1:2);
final String id4=getPdbID(2|4|8),chain=getChain();
if(id4==null) return null;
inferXYZ(pdbDownloadPepOrNuc(0x4000000|0x100000|0x80000|0x200000,id4,chain),null);
;
xyz=sideChain?getAtomXYZ(): getResidueCalphaCurrent();
}

return xyz;
}



public boolean residueHasXYZ(boolean fullLen,int idx){
final float[]ff=getResidueCalphaXYZ(null);
final int i=idx+(fullLen?0:subsetStart());
if(ff!=null) return!Float.isNaN(iThFloat(3*i,ff));
final int[]hasXYZ=_resHasXyz;
if(hasXYZ!=null){
final int i32=i>>>5;
return hasXYZ.length>i32 && (hasXYZ[i32]&(1<<i))!=0;
}
return false;
}

public int[]firstLastResidueWithXyz(){
final Object[]cached=cached();
int[]fstLst=(int[])fromCache(cached,23,MC[16]);
if(fstLst==null){
fstLst=new int[6];
cached[23]=fstLst;
for(int segment=0;segment<6;segment+=2){
fstLst[segment]=fstLst[segment+1]=-1;
final int
f=segment==0?0:segment==2?subsetStart():subsetEnd(),
t=segment==0?subsetStart():segment==2?subsetEnd():countResidues();
if(f<t&&f>=0){
search:
for(int i=Math.max(0,f);i<t;i++){
if(!residueHasXYZ(true,i)) continue;
for(int k=t;--k>=f;){
if(residueHasXYZ(true,k)){
fstLst[segment]=i;
fstLst[segment+1]=k;
break search;
}
}
}
}
}
}
return fstLst;
}

public synchronized long hashCodeCalpha(){
final float[]xyz=INTS[12]==1?getResidueCalphaXYZ(null):getAtomXYZ(null);
if(_hcXYZ==0) _hcXYZ=hashCdFloats(xyz,3*subsetStart(),3*subsetEnd());
return _hcXYZ;
}


private float _resolution=Float.NaN;

public void  setResolutionAngstroms(float r) {_resolution=r;}


public synchronized void setResidueCalphaXYZ(Object xyzOrText){
if(sze(xyzOrText)>0) _flags|=32768; else _flags&=~32768;
if(xyzOrText instanceof float[])xyzAddNans(_cAlpha=(float[])xyzOrText,0,0x7fffffff); else _cAlphaTxt=(byte[])xyzOrText;
_hcXYZ=0;
strapIncMC(15,this);
_cache=null;clr(_serverMC);
}
public synchronized int countCalpha(int max){
int count=0;
final float[]xyz=getResidueCalphaXYZ(null);
if(xyz==null) return 0;
for(int TO=min(subsetEnd()*3,xyz.length),i=subsetStart()*3;i<TO; i+=3){
if(!Float.isNaN(xyz[i]) && ++count>=max && max>0) break;
}
return count;
}
public synchronized byte[]resTypeUpperCaseForXYZ(){
if(!isProteinStructure()) return getResType();
final int nR=countRes();
final byte[]rt=getResType();
final Object[]cached=cached();
byte[]lc=(byte[])cached[7];
if(lc==null || cacheEmpty(cached,7,mc((15<<6)|8))){
cached[7]=lc=redim(lc,nR,0);
for(int i=nR;--i>=0;) lc[i]=(byte)(residueHasXYZ(false,i)?(rt[i]&~32): (32|rt[i]));
}
return lc;
}

public synchronized float[]getResidueCalphaCurrent(){
final Object[]cached=cached();
float[]caOri=getResidueCalphaXYZ(null);
final Matrix3D mx=getRotationAndTranslation();
if(caOri==null || isUnitOrNull(mx)) return caOri;
float[]ff=(float[])cached[3];
if(setMC(19,mc((15<<6)|18)) || ff==null){
cached[3]=ff=new float[min(caOri.length,subsetEnd()*3)];
mx.transformPoints(caOri,0,subsetEnd(),ff);
}
return ff;
}




public synchronized float[]getResidueCalphaXYZ(final Matrix3D m3d){
final Object[]cached=cached();
float[]xyz=_cAlpha;
if(xyz==null &&_cAlphaTxt!=null){
synchronized(TOKEN_FT){final int n=_siPrepareXYZ(_cAlphaTxt,0x7fffffff);xyz=copyOfFloats((float[])_siXyz,0,n*3);}
}
if(null==xyz){






if(_infXYZP!=null) _inferXYZ((1<<2));
else{
final float[]coord=getAtomXYZ(null);
if(sze(coord)>2){
Arrays.fill(xyz=new float[countResidues()*3],Float.NaN);
for(int ii[]=getResidueAtomIdx(),
CA=INTS[12]==1?'C'|('A'<<8): 'P',
i=countResidues();--i>=0;){
final int[]atoms=getResidueAtoms32(false,i);
if(ii[i]>=0){
final int j=idxOf(CA,atoms),fj3=(ii[i]+j)*3;
if(j>=0 && fj3+2<coord.length){
xyz[i*3  ]=coord[fj3  ];
xyz[i*3+1]=coord[fj3+1];
xyz[i*3+2]=coord[fj3+2];
}
}
}
}
_cAlpha=xyz;
}
xyz=_cAlpha;
}
if(xyz==null || isUnitOrNull(m3d)) return xyz;
if(m3d==_m3d) return getResidueCalphaCurrent();
float[]ff=(float[])cached[4];
if(ff==null || _m3dPreviewCalpha!=m3d || cacheEmpty(cached,4,MC[15]+m3d.mc())){
cached[4]=ff=redim(ff,min(xyz.length,subsetEnd()*3),0);
(_m3dPreviewCalpha=m3d).transformPoints(xyz,0,subsetEnd(),ff);
}
return ff;
}
public Protein getOneOwner(){
final Object[]owner=(Object[])getProperty(32);
if(owner!=null) for(Object o:owner) if((o=deref(o))!=null) return(Protein)o;
return null;
}
public synchronized Matrix3D getRotationAndTranslation(){
if(_m3d==null && isSobjectType(7,this)){
final Protein p=getOneOwner();
if(p!=null) return p._m3d;
}
return _m3d;
}
public synchronized void setRotationAndTranslation(Matrix3D m3d){
if(_m3d!=m3d){
strapIncMC(18,this);
_m3d=m3d;
cached()[2]=cached()[4]=null;

}
}
private Matrix3D _m3d,_m3dPreview,_m3dPreviewCalpha;
public synchronized View3d[]get3dViews(){
final UniqueList v=vChilds(-15);
if(v==null) return View3d.NONE;
for(Object v3d:v.asArray()) if(sp(v3d)==null) rmElmntFromV(v3d,v);
return(View3d[])v.asArray();
}


private Object _wrefs[];public Object[] wrefs(){if(_wrefs==null)_wrefs=new Object[2];return _wrefs;};



public synchronized void setIndexOffsetAA(int n){
if(INTS[14]!=(INTS[14]=n)) strapIncMC(3,this);
}
public void setIndexOffsetNT(int n){
if(INTS[15]!=(INTS[15]=n)) strapIncMC(3,this);
}



public int countResidues(){return INTS[12]==4?1: getResidueType().length;}
public void setSubset(String s){
int from=0,to=0;
if(sze(s)==0){
from=-0x80000000;
}else if(chrAt(0,s)=='-'){
to=((int)atol(s,1,0x7fffffff));
}else{
final int dash=s.indexOf('-');
from=xatoi(s)-1;
to=dash<0 || dash==s.length()-1?countResidues(): ((int)atol(s,dash+1,0x7fffffff));
}
setSubsetFT(from,to);
}
public synchronized void setSubsetFT(int start,int end){
if(start<0 && start!=-0x80000000) start=0;
if(start!=_subsS || end!=_subsE){
_subsS=start;
_subsE=end;
_cache=null;clr(_serverMC);
_hcXYZ=0;
clr(_mapRefSeqOffset);
}
}
public boolean isSubset(){return _subsS!=-0x80000000;}
public int subsetStart(){return max(0,_subsS);}
public int subsetEnd(){return _subsS==-0x80000000?countResidues():min(_subsE,countResidues());}

public Protein newProteinSubset(Object subset){
final String expr;
if(subset instanceof ResidueSelection[]||subset instanceof int[]){
int f=0x7fffffff,t=-1;
if(subset instanceof int[]){
f=firstResIdx(this)+columnToIndex(1,((int[])subset)[0]);
t=firstResIdx(this)+columnToIndex(1,((int[])subset)[1]-1)+1;
}else{
for(ResidueSelection s:(ResidueSelection[])subset){
if(sp(s)==this){
f=min(f,resSelFirstAmino(s));
t=max(t,resSelLastAmino(s));
}
}
}
if(t>=f)return this;
expr=s(new BA(99).a(f+1).a('-').a(t));
}else{
if(nxt(0,chrClas(-131),expr=s(subset),0,0x7fffffff)<0) return this;
}
final Protein p=new Protein();
p.setResidueType(getResType());
p.setName(addPfx("cloned_",getName()));
p.setResidueCalphaXYZ(copyOfFloats(getResidueCalphaCurrent(),3*subsetStart(),3*subsetEnd()));
pcp(85 |0x80000,this,p);



p.setSubset(expr);
return p;
}



public Object[] cacheSuperimpose(int it,Protein p,Object[] result){
Map[]mm=(Map[])cached()[24];
final int mc=p.MC[15]+p.MC[8];
if(result!=null){

if(mm==null) cached()[24]=mm=new Map[22];
if(mm[it]==null) mm[it]=new WeakHashMap();
mm[it].put(p,result);
result[5]=io(mc);

}else if(null!=(result=(Object[])gcp(p,xiThEl(it,mm))) && mc!=xatoi(result[5])){
result=null;
}
return result;
}



long _infXYZMatch;
Protein _infXYZP;
public float inferXYZ(Protein pp3d[],BA log){
if(fstNotNull(pp3d)==null) return Float.NaN;
final byte[]seq=getResType();
Protein bestP=null;
float bestScore=Float.MIN_VALUE;
byte[][]bestGapped=null;
for(Protein p3d:pp3d){
if(p3d==null) continue;
final byte[][]aligned=smithWaterman(p3d.getResType(),seq,null);
if(aligned!=null){
final float score=pairAignScore(-10f,-2f,aligned[0],aligned[1],0,0x7fffffff,0);
if(score>bestScore){
bestGapped=aligned.clone();
bestScore=score;
bestP=p3d;
}
}
}
if(bestP!=null){
{



if(log!=null){
log.a("inferXYZ(").a(bestP).a(',').a(this).a(") score=").a(bestScore).a('\n');
aliWithMidline(4,bestGapped[0],-0x80000000,"",bestGapped[1],-0x80000000,"",99999,log);
log.aln();
}

_infXYZGapped=bestGapped;
_infXYZP=bestP;
_infXYZTried=0;
_inferXYZ((1<<1));
return bestScore;
}
}
return Float.NaN;
}

private static short[][]arrySetIth(short[]v,int i,short[][]aa) {if(aa==null) aa=new short[i+1][]; aa[i]=v; return aa;}
private static int[][]arrySetIth(int[]v,int i,int[][]aa) {if(aa==null) aa=new int[i+1][]; aa[i]=v; return aa;}
private static int[]arrySetIth(int v,int i,int[]aa) {if(aa==null)aa=new int[i+1]; aa[i]=v; return aa;}
private static byte[]arrySetIth(byte v,int i,byte[]aa,byte fill){if (aa==null) {aa=new byte[i+1];if(fill!=0) Arrays.fill(aa,fill);} aa[i]=v; return aa;}
private void _inferXYZ(int options){
final Protein p=_infXYZP;
if(p==null) return;
p._fromSrc((1<<3));
final int opt=options&~_infXYZTried;
_infXYZTried|=options;
if(opt==0) return;
final byte[]ali[]=_infXYZGapped,gapped3D=ali[0],gapped=ali[1],sst3D=0!=(opt&(1<<1))?p.getResidueSecStrType():null,rt3D=p.getResType(),ins3D=p.getResidueInsCode();

int[]anu3D=null,idx3D=null,atom323D[]=null,anus3D[]=null;
short[][]elements=null;
if(0!=(opt&(1<<3))){
p.getAtomXYZ();
idx3D=p.getResidueAtomIdx();
anus3D=p._resAtomNumOffsets;
anu3D=p.getResidueAtomNumber();
atom323D=p._atom32;
elements=p._elements;
}
final int
num[]=0!=(opt&(1<<1))?new int[subsetEnd()]:null,
colL=min(gapped.length,gapped3D.length);
float[]alpha=null;
byte[]ins=null,sst=null;
int[]idx=null,anu=null,nam=null,atom32[]=null,anus[]=null;
short[][]ee=null;
int colFrom=0,countMatch=0,countAll=0;
final boolean[]lettr=chrClas(133);

for(int c=0;c<colL;c++){
if(isChrClas(lettr,gapped,c) && isChrClas(lettr,gapped3D,c)) break;
colFrom=c+1;
}
if(alpha!=null) Arrays.fill(alpha,Float.NaN);
if(0!=(opt&(1<<1))) Arrays.fill(num,-0x80000000);
boolean[]mismatch=null;
{

int countCalpha=0,hasXYZ[]=null;
for(int
dst=idxOfLetters(gapped,getResType(),0,0x7fffffff)+countChrClas(lettr,gapped,0,0x7fffffff)-1,
src=idxOfLetters(gapped3D,rt3D,0,0x7fffffff)+countChrClas(lettr,gapped3D,0,0x7fffffff)-1,
col=colL;--col>=0;){
final int dstFL=dst+subsetStart(),srcFL=src+p.subsetStart();
if(dst<0 || src<0) break;
if(dstFL>=subsetEnd() || srcFL>=p.subsetEnd()) continue;
final byte g=gapped[col],g3=gapped3D[col];
final boolean dstL=g>0&&lettr[g],srcL=g3>0&&lettr[g3];
if(srcL && col>=colFrom){
if((g|32)==(g3|32))  countMatch++;
else{
if(mismatch==null) mismatch=new boolean[dst+1];
mismatch[dst]=true;
}
countAll++;
}
if(dstL && srcL){
if(srcFL<sze(elements))ee=arrySetIth(elements[srcFL],dstFL,ee);
if(srcFL<sze(atom323D))atom32=arrySetIth(atom323D[srcFL],dstFL,atom32);
if(srcFL<sze(anus3D))anus=arrySetIth(anus3D[srcFL],dstFL,anus);
if(srcFL<sze(idx3D)) {
if(idx==null)Arrays.fill(idx=new int[dstFL+1],-1);
idx[dstFL]=idx3D[srcFL];
}

if(srcFL<sze(anu3D))anu=arrySetIth(anu3D[srcFL],dstFL,anu);
if(srcFL<sze(sst3D))sst=arrySetIth(sst3D[srcFL],dstFL,sst,(byte)' ');
if(0!=(opt&(1<<1))){
num[dstFL]=p.resnAt(4,srcFL);
if(srcFL<sze(ins3D))  ins=arrySetIth(ins3D[srcFL],dstFL,ins,(byte)0);
}
{
final int n4=iThInt(srcFL,p.getResidueName32());
if((n4!=-0x80000000 && (n4&0xFFffFF)!=(toThreeLetterCode(rt3D[src])&0xFFffFF))) nam=arrySetIth(n4,dstFL,nam);
}
{
final float[]alpha3d=0!=(opt&(1<<2))?p.xyzByID(false):null;

if(alpha3d!=null){
final int i=srcFL*3+2;
if(i<alpha3d.length){
final int iDst=dstFL*3+2;
if(alpha==null) Arrays.fill(alpha=new float[iDst+1],Float.NaN);
alpha[iDst  ]=alpha3d[i  ];
alpha[iDst-1]=alpha3d[i-1];
alpha[iDst-2]=alpha3d[i-2];
countCalpha++;
}
}else if(p._resHasXyz!=null && p.residueHasXYZ(true,srcFL)){
final int a32=dst>>5;
if(hasXYZ==null) hasXYZ=new int[a32+1];
hasXYZ[a32]|=(1<<dst);
}
}
}
if(dstL) dst--;
if(srcL) src--;
}
_resHasXyz=hasXYZ;
if(countCalpha>0 && onlyOnce(36)) baOut("inferXYZ Calpha").aln(" \u001B[42m\u001B[30mDone\u001B[0m ");
}
_infXYZMatch=(((long)countMatch)<<32)|countAll;
setChain(p.getChain());
if(0!=(opt&(1<<1))) setResn(num,ins);
if(countAll-countMatch<2 && nam!=null) setResidueName32(nam);
if(alpha!=null) setResidueCalphaXYZ(alpha);
if(sst!=null) setResidueSecStrType(sst);
if(0!=(opt&(1<<3))){
setAtoms(p.getAtomXYZ(null),idx,atom32,ee);
setChainsByType(p._chainsByType);
setAtomSerial(anu,anus);
}
if(_vv!=null) clr(_vv[4]);
addToProt(2,p.getMolecules(4),this);
final String pdbId=p.getPdbID(2);
if(pdbId!=null && setPdbID(4,pdbId)) strapIncMC(22,this);
;

{
BA sb=new BA(99).a(pdbId).a(' ').and(p.getProperty(4)," Identity: ");
if(countAll>0) sb.a(100*countMatch/countAll).a('%');
OBJECTS[25]=s(sb.replaceChar('\n',' '));
}
for(ResidueAnnotation a0:p.residueAnnotations()){
if(a0.whereFeatureLoadedFrom()==16384){
final ResidueAnnotation s=new ResidueAnnotation(this);
for(ResidueAnnotation.Entry e: a0.entries()) s.addE(0,e.key(),e.value());
addToProt(s
.setFeatureSrc(16384)
.annoAdd(3,countAll==countMatch?"By identity": "By similarity")
.annoAdd(4,pdbId),
this);
}
}
rmResidueSelectionWithName("Mismatch_with_3D_model");
if(mismatch!=null){
final ResidueAnnotation s=new ResidueAnnotation(this);
runCR1(547,s,newColrA(0xFF0A0A|0xff000000));
s.setStyle(8);
s.setSelectedAminoacids(mismatch,firstResIdx(this));
s.annoAdd(1,"Mismatch_with_3D_model")
.annoAdd(10,baClr(157).a("Residues not matching the 3D-model ").a(pdbId))
.annoAdd(4,pdbId);
addToProt(s,this);
}

}
public synchronized void detach3DStructure(){
if(getPdbID(4)!=null){
setPdbID(4,null);
setResidueCalphaXYZ(null);
setResidueSecStrType(null);
setResn(null,null);
rmResidueSelectionWithName("Mismatch_with_3D_model");
}
}



public boolean isProteinStructure(){
return _resNum!=null || getChain()!=null || _cAlpha!=null || isLoadedFromStructureFile();
}
public boolean isLoadedFromStructureFile(){
;

final int bid=bidForClass(getProperty(33));
return bid==1330 || bid==1331;

}




public Protein[]getProteinsSameComplex(){
final int N=sze(_vComplex);
if(N>0){
final Protein[]pp=new Protein[N];
int count=0;
for(int i=0;i<N;i++) if((pp[count]=iThProt(i,_vComplex))!=null && pp[count]!=this) count++;
return chSze(pp,count,Protein.class);
}
final Protein[]ppAli=strapProteins();
final String thisPdb=delIdx(0x2000000|'_',getPdbID(2));
if(ppAli.length>0 && sze(thisPdb)>0){
final Protein[]pp=new Protein[ppAli.length];
int count=0;
for(Protein p:ppAli) if(p!=null && strEquAt(0,thisPdb,p.getPdbID(2),0,0x7fffffff)) pp[count++]=p;
return chSze(pp,count,Protein.class);
}
return NONE;
}
public void setProteinsSameComplex(Protein[]pp){
if(clr(_vComplex)==null) _vComplex=new ArrayList();
for(Protein p:pp) if(this!=p&&p!=null) _vComplex.add(wref(p));
}




public synchronized void setExons(int[][]fromTo,boolean reverseComplement){
_cache=null;clr(_serverMC);
_transFT=fromTo!=null&&fromTo.length==0?new int[][]{{0},{countNucleotides()}}:fromTo;

strapIncMC(26,this);
if(_revCompl!=(_revCompl=reverseComplement))  strapIncMC(30,this);
if(_charSeq instanceof byte[]&& fileSoftRef()!=null) _charSeq=newSoftRef(_charSeq);
INTS[10]=-1;
_ntCount=-1;
_triplets=null;
clr(_mapRefSeqOffset);
clr(_vIdByIdent);
}
public boolean isTranslated(){return exons()!=null && !areNucleotidesProjected();}
public boolean isReverseComplement(){return _revCompl;}
public synchronized byte[]getNucleotides(){
if(!isTranslated()) return null;
final byte[]cc=getCharSequence();
setMC(25,mc((2<<6)|30));
return cc;
}

public synchronized int countNucleotides(){
if(_ntCount<0) _ntCount=sze(getNucleotides());
return _ntCount;
}

public synchronized boolean onlyActgn(){
final byte[]aa=getResType();
final int nR=countRes();
if(_ACTGNmc!=(_ACTGNmc=MC[8]) || _actgn==0){
int count=0;
for(int i=nR;--i>=0;){
final int c=aa[i]|32;
if(c=='a' || c=='c' || c=='t' || c=='g' || c=='u') count++;
}
_actgn=count>1 && count/(float)nR>0.95?1: -1;
}
return _actgn==1;
}
public byte[]triplets(){
if(areNucleotidesProjected()) return _pnCDS;
final int[][]exons=exons();
final boolean rev=isReverseComplement();
byte[]nu=_triplets;
if(setMC(31,mc((2<<6)|26)) || nu==null){
final byte[]nucl=getNucleotides();
nu=findTriplets(nucl,0x7fffffff,exons,rev,nu);
_triplets=substrgB(2,nu,0,strLen(nu));
}
return nu;
}

public synchronized byte[]getResidueType(){
final Object[]cached=cached();
final byte[]triplets=triplets();
byte[]aa=(byte[])cached[8];
if(setMC(9,mc((26<<6)|31)) || aa==null){
final String translated=iThStrg(7,getCDS(INTS[10]));
if(translated!=null) cached[8]=aa=toByts(translated);
else{
if(!isTranslated()) return getCharSequence();
cached[8]=aa=triplets2aa(true,triplets,0x7fffffff);
}
}
return aa;
}
private int[][]_transFT;
public int[][]exons(){return _transFT;}



public synchronized int[]coding2allPositions(){
final Object[]cached=cached();
final boolean rev=isReverseComplement();
final int[][]exons=exons();
if(exons==null) return null;
int[]kk=(int[])cached[11];
if(setMC(29,mc((26<<6)|2)) || kk==null){
final int n3=Bitset.count(0x7fffffff,exons);
if(kk==null || kk.length<n3) kk=redim(kk,n3,33);
Arrays.fill(kk,0,n3,-1);
cached[11]=kk;
for(int idx0=3*subsetStart(),
ff[]=exons[0],tt[]=exons[1],b=0,t=0;b<ff.length;b++){
for(int i=ff[b];i<tt[b] && t<n3;i++){
final int k=(rev?n3-++t: t++)-idx0;
if(k>=0 && k<kk.length) kk[k]=i;
}
}
}
return kk;
}

public int aa2ntZ(int ia,int c012){
final int[]c2a=coding2allPositions();
return iThInt(3*ia+c012,c2a);
}

public int nt2aaZ(int iN){
final int[][]xx=exons();
if(iN<0||!Bitset.get(iN,xx)) return -1;
final int n=Bitset.count(iN,xx);
return(isReverseComplement()?triplets().length-n-1: n)/3-subsetStart();
}

public boolean areNucleotidesProjected(){return _pnCDS!=null;}
public void projectNucleotides(byte[]nt,String cds){
_pnCDS=nt;
parseCDS(cds);
}
public static byte[]findTriplets(byte[]dna,int len,int[][]exons,boolean rev,byte[]buf){
if(dna==null) return null;
final int L=min(dna.length,len),ff[]=exons[0],tt[]=exons[1],n=Bitset.count(0x7fffffff,exons);
final byte[]aa=buf==null||buf.length<n?new byte[n]: buf;
int ia=0;
for(int b=0;b<ff.length;b++){
for(int i=ff[b];i<tt[b];i++){
final int nt=i<0 || i>=L?'n': (rev?COMPLEMENT_BASE[127&dna[i]]: dna[i]);
if(ia>=n){

break;
}
aa[rev?n-ia-1:ia]=(byte)nt;
ia++;
}
}
if(ia<aa.length) Arrays.fill(aa,ia,aa.length,(byte)0);
return aa;
}




public static boolean unableParseCDS(Object cds){
if(cds==null) return true;
if(strchr(':',cds,0,0x7fffffff)>=0){
if(onlyOnce(5)) baOut("\u001B[45m\u001B[41mWarning\u001B[0m ").a(" unableParseCDS ").a(cds).aln(" Reason: Reference to external sequence file. ");
return true;
}
return false;
}

public boolean asTranslated(boolean printErr,byte[]aa,int L,String cds){
final byte[]
triplets=findTriplets(getCharSequence(),0x7fffffff,Bitset.parseBitset(cds,L),strstr(0x80000,"compl",cds,0,0x7fffffff)>=0,null),
predict=triplets2aa(true,triplets,0x7fffffff);
if(predict.length!=L){
if(printErr&&onlyOnceHC(320,cds)){
baOut("\u001B[41mError\u001B[0m ").a(this).a('\t').a(cds).a(" Predicted and given aminoacid sequence ").a("have different length. ").a(predict.length).a('/').a(L).aln()
.aFT(predict,0,predict.length).aln().aln(aa);
}
return false;
}
final long ratio=alignmentIdentity(aa,predict,0,L);
if((int)(ratio>>>32)!=L){
baOut("\u001B[45m\u001B[41mWarning\u001B[0m ").a(cds).a(" Predicted and given aminoacid sequence ").a("differ [").a(L-(int)(ratio>>>32)).a('/').a(L).aln("].");
return false;
}
return true;
}
public String[]getCDS(int i) {return (String[])xiThEl(i,_vCDS);}
public int countCDS(){return sze(_vCDS);}
public synchronized void addCDS(String[]cdsData){
(_vCDS==null?_vCDS=new ArrayList(): _vCDS).add(cdsData);
if(cdsData[0]==null) assrt();
}
public boolean applyCDS(int i){
final String[]data=getCDS(i);
if(data==null) return false;
parseCDS(data[0]);
INTS[10]=i;
final String refs=iThStrg(5,data);
if(refs!=null){
clr(_vIds);
for(String xRef:splitTkns('\t',refs)) addSeqRef(0,xRef);
}
return true;
}

public boolean setCDS(String f){
if(sze(f)>0){
if(0>nxt(0,chrClas(-132),f,0,0x7fffffff)) return applyCDS(xatoi(f));
if(strstr(0,"..",f,0,0x7fffffff)>=0){
parseCDS(f);
return true;
}
if(nxt(0,chrClas(133),f,0,0x7fffffff)>=0){
for(int i=countCDS();--i>=0;) if(idxOfStrg(0x80000|(4096|8192),f,getCDS(i))>=0) return applyCDS(i);
}
}
return false;
}






public synchronized void parseCDS(Object txt){
if(unableParseCDS(txt)){setExons(EXONS_UNABLE_TO_PARSE,false);return;}
final byte[]z=toByts(txt);
final int[][]exons;
final boolean rev;

if((z[2]|32)=='x'){
if(z.length<3) return;
rev=z[0]+z[1]=='C'+'R';
final boolean[]bb=new boolean[z.length-2];
for(int i=bb.length;--i>=0;) bb[i]=(z[i+2]&32)==0;
exons=Bitset.fromBool(bb);
} else

{
rev=strstr(0,"compl",z,0,0x7fffffff)>=0;
exons=Bitset.parseBitset(z,getCharSequence().length);
}
setExons(exons,rev);
final String molType=wordAt(-131,txt,strstr(65536,"moleculeType=",txt,0,0x7fffffff),0x7fffffff);
if(molType!=null) setMoleculeType(toByts(molType),0,0x7fffffff);
}



private transient Object _cache;
private final int[]CACHE_MC=new int[25];
final int[]MC=new int[42];
private int _mcSubset,_mcResSelSorted,_mcGap  ,_mcResSelNotEmpty;
public int mc(int mcs){
int mc,sum=0;
while((mc=(mcs&((1<<6)-1)))!=0){
sum+=MC[mc]+MC_PROT_NOT_SPECIFIED[mc];
mcs>>>=6;
}
return sum;
}

public boolean setMC(int type,int value){
if(MC[type]!=value){
MC[type]=value;
return true;
}
return false;
}

Object[]cached(){
Object[]r=(Object[])deref(_cache);
if(r==null) _cache=newSoftRef(r=new Object[25]);
return r;
}

private Object fromCache(Object[]cache,int type,int mc){
if(CACHE_MC[type]!=mc){
CACHE_MC[type]=mc;
cache[type]=null;
}
return cache[type];
}
private boolean cacheEmpty(Object[]cache,int type,int mc){
if(CACHE_MC[type]!=mc){
CACHE_MC[type]=mc;
cache[type]=null;
return true;
}
return false;
}



int[]_resGap;




public synchronized void setResidueGap(int[]gg){
for(int i=sze(gg);--i>=0;){
if(gg[i]<0){
final int nR=countRes();
if(i<nR && onlyOnce(37))  baOut("\u001B[41mError\u001B[0m ").aIntArray(gg,0,nR).special(1).aln();
gg[i]=0;
}
}
_resGap=gg;_mcGap++; strapIncMC(44,null);
}
public synchronized void setResidueGapAt(boolean add,int iA,int gap){
final int nR=countRes();
int[]gg=getResGap();
if(iA<0 || iA>=nR || add && gap==0) return;
if(sze(gg)<=iA){
if(gap==0) return;
gg=chSze(gg,nR);
}else if(add){
gap+=gg[iA];
}
if(gap<0) gap=0;
if(gap!=gg[iA]){
gg[iA]=gap;
_resGap=gg;_mcGap++; strapIncMC(44,null);
}
}
public synchronized int[]getResGap(){
final int n=countRes();
int[]gg=_resGap;
if(gg!=null && (gg.length<n || gg.length>n+99)){
gg=_resGap=chSze(gg,n);
}
return gg;
}

public synchronized int getResGapAt(int i){
final int[]gg=getResGap();
return i>=0 && i<countRes() && gg!=null && i<gg.length?gg[i]:0;
}






private Gaps2Columns _g2c,_g2cAli;
public void setGaps2Columns(Gaps2Columns g2c) {_g2c=g2c;_cache=null;clr(_serverMC);;};
public synchronized int[]getResColumn(){
final Object[]cached=cached();
final int nR=countRes();
getResType();
boolean wide=(_flags&64)==0 || (_globFlags&2)!=0;
Gaps2Columns gap2col=_g2c;
if(gap2col==null){
if(OBJECTS[16]!=null) _g2cAli=wide?null:Strap.strapG2C();
if(null==(gap2col=_g2cAli)) wide=true;
}
final int[]gg=getResGap(),wide2view=wide?null:gap2col.wide2viewColumnNoSync();
int[]cc=(int[])cached[wide?19:15];
if(cc==null || cc.length<nR || cacheEmpty(cached,wide?19:15,MC[8]+_mcGap+(wide?0:gap2col.mc()))){
if(wide){
cached[19]=cc=redim(cc,nR,33);
int po=-1,ia=0;
if(gg!=null) for(int to=min(nR,gg.length);ia<to;ia++) cc[ia]=po+=gg[ia]+1;
for(;ia<nR;ia++) cc[ia]=(++po);
}else{
cached[15]=cc=Gaps2Columns.computeColumns(wide2view,gg,nR,cc);
}
}
return cc!=null?cc: NO_int;
}

public synchronized int getResColumnAt(int i){
if(i<0||i>=countRes()) return -0x80000000;
if(_resGap==null) return i;
final int[]cc=getResColumn();
return i<cc.length?cc[i]:-0x80000000;
}

public synchronized int getResColumnMax(){
final int nR=countRes();
if(nR==0) return -0x80000000;
if(_resGap==null) return nR-1;
return getResColumn()[nR-1];
}

public synchronized int[]columnsToIndices(){
final Object[]cached=cached();
getGappedSequence(false);
return(int[])_gapped(cached)[16];
}

public synchronized int columnToIndex(int goUp,int col){
final int c2i[]=columnsToIndices(),max=getResColumnMax();
if(col<0) return goUp==1?0:-1;
if(col>max || col>=c2i.length) return goUp==-1?countRes()-1:-1;
int ia=c2i[col];
if(ia<0 && goUp!=0){
if(goUp==1){
while(col<=max&&(ia=c2i[col])<0) col++;
}else{
while(col>=0&&(ia=c2i[col])<0) col--;
}
}
return ia;
}




public synchronized byte[]getGappedSequence(boolean exactLength){
final Object[]cached=cached();
byte[]gg=(byte[])_gapped(cached)[17];
if(exactLength && gg!=null){
final int L=getResColumnMax()+1;
if(gg.length!=L) cached[17]=gg=chSze(gg,L);
}
return gg;
}

private Object[]_gapped(Object[]cached){
final byte[]aa=getResType();
final int[]cc=getResColumn();
byte[]gs=(byte[])cached[17];
if(setMC(13,MC[8]+CACHE_MC[19]+CACHE_MC[15]+_mcGap+MC_GLOBAL[45]) || gs==null){
final int n=aa==null||aa.length==0||cc.length==0?0:countRes();
int[]c2i;
if(n==0){
c2i=NO_int;
gs=NO_byte;
}else{
final int maxCol=cc[n-1],maxCol1=maxCol+1,c0=cc[0];
if(gs==null||gs.length<maxCol1) gs=new byte[maxCol1 +11];
if(c0>0) Arrays.fill(gs,0,c0,(byte)' ');
if(c0<maxCol) Arrays.fill(gs,c0,maxCol,(byte)'-');
if(maxCol1<gs.length) Arrays.fill(gs,maxCol1,gs.length,(byte)0);
c2i=redim((int[])cached[16],maxCol1,11);
Arrays.fill(c2i,0,maxCol1,-1);
try{
for(int i=n;--i>=0;){
final int col=cc[i];
gs[col]=aa[c2i[col]=i];
}
}catch(IndexOutOfBoundsException iobex){
if(onlyOnce(32)) baOut("\u001B[41mError\u001B[0m ").a(this).a(" getGappedSequence: ").aIntArray(cc,0,n).aln();
c2i=count01234(0,null,0,maxCol1);
gs=aa;
}
}
cached[16]=c2i;
cached[17]=gs;
}
return cached;
}





public synchronized void inferGapsFromGappedSequence(byte[]seq){
if(seq==null) return;
final int[]gaps=new int[countRes()];
for(int lastPos=-1,ia=0,pos=0;pos<seq.length && ia<gaps.length;pos++){
final int c=seq[pos]|32;
if(('a'<=c&&c<='z')){
gaps[ia++]=pos-lastPos-1;
lastPos=pos;
}
}
setResidueGap(gaps);
}
public synchronized void setGappedSequence(byte[]seq,int len){
setResidueType(allLettersB(seq,0,len));
inferGapsFromGappedSequence(seq);
}


public boolean parseGaps(byte[]z,int L){
if(z==null) return false;
{
final boolean[]lettr=chrClas(133),digt=chrClas(132);
final int[]gaps=new int[countChrClas(lettr,z,0,L)];
for(int po=0,ga=0,i=0;i<L;i++){
final int c=z[i];
if(c>0&&lettr[c]){
gaps[po++]=ga;
ga=0;
continue;
}
if(('0'<=c&&c<='9') || c=='-'){
int gap=z[i]-'0';
while(i+1<L && isChrClas(digt,z,i+1)) gap=10*gap+z[++i]-'0';
ga+=gap;
}
}
setResidueGap(gaps);
}

final byte[]aa=getResType();
for(int nR=countRes(),i=0,ia=0;i<L && ia<nR;i++)if(('a'<=z[i]&&z[i]<='z')) aa[ia++]|=32;
return true;
}




public int getWebTokenIdx(){
final Object t=OBJECTS[9],tt[]=(Object[])OBJECTS[10];
if(_tokenIdx==-0x80000000 && t!=null && tt!=null) _tokenIdx=idxOf(t,tt);
return _tokenIdx;
}




private Collection _save(int file,File dir,Object txt,Collection vErr){
final File f=fileOfProteinForDir(file,this,dir);
return null==wrte(32,f,txt)?adUniqNew(f,vErr):vErr;
}
public void save(File dir,BA sbTmp,BA error){
clr(sbTmp);
Collection v=null;
if(dir!=iFile(50)){
{
final int[]gg=getResGap();
int count=0;
if(gg!=null && (dir==iFile(53) || _mcGap>0)){
final int n=min(countRes(),gg.length);
for(int i=0;i<n;i++){
if(gg[i]>0) {sbTmp.a(gg[i]); count++;}
sbTmp.a('X');
}

}
v=_save(5,dir,count==0?null:sbTmp,v);
}

v=_save(4,dir,!isTranslated()?null:Bitset.toText(exons(),isReverseComplement(),clr(sbTmp)),v);



v=_save(1,dir,getIntProperty(14)==0?null:s(getIntProperty(14)),v);




v=_save(3,dir,getPdbID(4),v);
final Matrix3D m3d=getRotationAndTranslation();



v=_save(8,dir,m3d==null?null:m3d.toText(4,"",clr(sbTmp)),v);
}
ResidueAnnotation.saveResan(this,dir,clr(sbTmp));
if((v=_save(2,dir,sbTmp,v))!=null && sze(error)>0) error.aln("Error: Could not write").join('\n',v).aln();
}




public String iconURL(){
Object url=_iconURL;
if(url==null) _iconURL=url=orO(toStrgTrim(readBytes(fileOfProteinForDir(6,this,null))),alias(8));
return url==alias(8)?null: (String)url;
}
public void setSequenceIcon(String dd){
_icon=_iconURL=_icon64=null;
if(dd==null) {_icon=""; fileDel(0,fileOfProteinForDir(6,this,null));};
for(String d:splitTkns(dd)){
if(strEquAt(0,arry(2146),d,0,0x7fffffff)){

if(withGui()){
final Object i64=runCR(819,mkInstance(0x40000000,iClass(26)),d,null);
if(i64!=alias(8)){
_icon=i64;
wrte(fileOfProteinForDir(9,this,null),_icon64=new BA(d));
}
} else

_icon64=new BA(d);
}else{

_iconURL=d;
if(withGui()) wrte(32,fileOfProteinForDir(6,this,null),d);

}
}
strapIncMC(6,this);
}
public BA iconBase64(){
Object d=_icon64;
if(d==null) _icon64=d=orO(readBytes(fileOfProteinForDir(9,this,null)),alias(8));
return d==alias(8)?null:(BA)d;
}



public void setBalloonText(String t){
_balloonDirect=sze(t)==0?null:t;
_balloon[0]=_balloon[1]=null; strapIncMC(6,this);
}
public String balloonText(int opt){

if(_balloon==null) _balloon=new String[2];
if(_balloon[0]==null ||  _fBalloon==null || _balloonWhen!=_fBalloon.lastModified()){
_balloonWhen=(_fBalloon=fileOfProteinForDir(7,this,null)).lastModified();
BA ba=readBytes(_fBalloon);
if(_balloonDirect!=null) (ba==null?ba=new BA(0): ba).aln().a(_balloonDirect);
_balloon[0]=toStrgN(ba);
_balloon[1]=s(baClr(157).aHtmlCode(ba));
}

return orS(_balloon[0!=(opt&2)?1:0],null) ;
}




private final static Object[]_pLabel=new Object[2];
private final long HASH_CODE32=uintToLong(hashCode())<<32,_when=System.currentTimeMillis(),_rendMC[]=new long[1];

public int exonForAminoZ(int ia,int codon012){
final int[][]ee=exons();
if(ee==null) return -1;
final boolean rev=isReverseComplement();
final int n=3*(ia+subsetStart())+codon012,exNum=Bitset.selected2block(rev?Bitset.countAll(ee)-1-n:n,ee);
return rev?ee[0].length-exNum-1:exNum;
}



private UniqueList[]_vv;
UniqueList vChilds(int i){
UniqueList v=_vv==null?null:_vv[i<0?-i:i];
if(v==null && i>0){

if(_vv==null) _vv=new UniqueList[18];
v=_vv[i]=new UniqueList(i==15?41:
i==8 || i==11 || i==13?38:
1<=i && i<=7?36:
39);
runCR1(207,v,iConst(1927,i));
if(i==15) v.addHookCR(1561,this,0);
}

if(v!=null && i==13){
final UniqueList v0=vChilds(8);
if(_mcResSelNotEmpty!=(_mcResSelNotEmpty=v0.mc()+MC[34])){
clr(v);
for(Object s:v0.asArray()){
if(s!=null&&0!=(((ResidueSelection)s).getVisibleWhere()&32768) || nxtTrue(((ResidueSelection)s).getSelectedAminoacids(),0,0x7fffffff)>=0) v.add(s);
}
}
}

return v;
}
public Protein[]getMolecules(int i) {final UniqueList v=vChilds(-i); return v!=null?(Protein[])v.asArray(): Protein.NONE;}






public ResidueSelection[]resSel(int i) {final UniqueList v=vChilds(-i); return v!=null?(ResidueSelection[])v.asArray(): ResidueAnnotation.NONE;}
public synchronized ResidueAnnotation[]residueAnnotations(){return (ResidueAnnotation[])resSel(9);}

public synchronized ResidueSelection[]allResidueSelectionsSorted(){
if(_mcResSelSorted!=(_mcResSelSorted=mc((32<<6)|39))) sortArry(vChilds(11),chUtils(46));
return resSel(11);
}





boolean _rmOrAdd(int opt,Object s){
if((s=deref(s))!=null &&  (0!=(opt&1)||_vv!=null)){
if(szeVA(s)>=0){
boolean changed=false;
for(int i=szeVA(s);--i>=0;) changed|=_rmOrAdd(opt,xiThEl(i,s));
return changed;
}
if(s instanceof File && 0!=(opt&1)) return _rmOrAdd(1,readPepOrNuc(16384,null,s));
final int t=sobjectType(s);

if(t>=0){


final Protein h=derefProt(s);
final int general=8<=t && t<=14?11: h!=null?6: 15;
if(h!=null && h.getResidueCalphaXYZ(null)!=null){
for(Protein child:getMolecules(h.INTS[12])){
if(child.getResidueCalphaXYZ(null)!=null && child.hashCodeCalpha()==h.hashCodeCalpha()){
baLog(17).a("@1"+"\u001B[42m"+" ").a(iConst(2023,t)).a(' ').a(h).aln(" ALREADY_ATTACHED_IGNORE."+"\u001B[0m");
return false;
}
}
}
final boolean isCursor=s instanceof ResidueSelectionImpl&&(0!=(((ResidueSelectionImpl)s)._opt&1024));
if(0!=(opt&1)?vChilds(general).add(s): rmElmntFromV(s,_vv[general])){
for(int i=18;--i>=0;){
if(i==general) continue;
if(0!=(opt&1)){
if(this!=s && sobjectComprises(i,t) &&!isCursor&&i==8) vChilds(i).add(s);
}else if((general==11?8: h!=null?1:0)<=i&&i<=(general==11?14: h!=null?7:0x7fffffff)){
rmElmntFromV(s,_vv[i]);
}
}
if(general==11){
if(t==10) strapIncMC(46,null);
strapIncMC(32,this);
if(0!=(opt&1)){
final boolean enab=runCR(541,s)!="FALSEr";
if(t!=8){
if(t==10){
final boolean e=vChilds(enab?10:14).add(s);
if(rmElmntFromV(s,vChilds(enab?-14:-10))||e) strapIncMC(46,null);
}else{
vChilds(12).add(s);
}

if(enab) vChilds(9).add(s);
else if(t==10) rmElmntFromV(s,vChilds(-9));
}
if(sp(s)!=this) setProt(this,s);






}
if(withGui() && !isCursor) updateChildTreeP(t!=8?s:vChilds(-8),null,this);
}else if(h!=null){
if(0!=(opt&1)){
h.setProperty(32,adToArry(2,wref(this),(Object[])h.getProperty(32),null));

if(0!=(opt&4)){
final Matrix3D m3d=getRotationAndTranslation();
if(!isUnitOrNull(m3d)){
final Matrix3D m3dInv=m3d.newInverse();
h._atomXYZ=m3dInv.transformPoints(h.getAtomXYZ(null),0,0x7fffffff,null);
h.setResidueCalphaXYZ(m3dInv.transformPoints(h.getResidueCalphaXYZ(null),0,0x7fffffff,null));
strapIncMC(16,this);
_cache=null;clr(_serverMC);
}
}

}else{
final Object[]owner=(Object[])h.getProperty(32);
setIthEl(idxOf(wref(this),owner),null,owner);
}
strapIncMC(40,this);
strapEvtDispatch(34|(1<<8)*333);
}else{
strapIncMC(41,this);
}
}
}
rmElmntFromV(s,vNoClr(240|0x40000));
return true;
}
return false;
}
public void rmResidueSelectionWithName(Object name){
final int hc=name.hashCode();
for(ResidueSelection s:resSel(11)){
final String n=nam(s);
if(n!=null && n.hashCode()==hc && n.equals(name)) rmFromProt(s,this);
}
}

public byte[]selAminos(){
if(_vv==null) return NO_byte;
final Object[]cached=cached();
final byte[]cSelA=(byte[])cached[18];
if(setMC(36,modic(_vv[11])+MC[33]+MC[3]+MC[7]) || cSelA==null){
byte[]bbbA=NO_byte;
for(ResidueSelection s:resSel(11)){
if(vis123isThere((1<<7)|16384,s)){
final boolean[]bbA=resSelPosDisplayed(s) ;
final int nR=countRes(),selOffsetA=s.getSelectedAminoacidsOffset()-firstResIdx(this),lastTrue=lstTrue(bbA);
if(lastTrue>=0){
if(bbbA==NO_byte){
if(cSelA!=null && nR<=cSelA.length) clr(bbbA=cSelA);
else bbbA=new byte[nR+9];
}
final int n=min(lastTrue+1,nR-selOffsetA);
for(int i=Math.max(0,-selOffsetA);i<n;i++) if(bbA[i] && bbbA[i+selOffsetA]<127) bbbA[i+selOffsetA]++;
}
}
}
cached[18]=bbbA;
}
return(byte[])cached[18];
}
public synchronized ResidueSelection[]aaSelectionsAtZ(int f,int t,int where){
final Collection v=vNoClr(0x20000000|16);
aaSelectionsAtZ(f,t,where,v);
return toArryClr(v,ResidueSelection.NONE);
}
synchronized boolean aaSelectionsAtZ(int aFrom,int aTo,int where,Collection v){
boolean found=false;
final int nR=countRes();
if(aTo==(-0x80000000+1)) aTo=aFrom+1;
if(aFrom>=aTo || aTo<1 || aFrom >=nR) return false;
for(ResidueSelection s:resSel(11)){
if(where!=0 && !vis123isThere(where,s)) continue;

{
final int it=instType(s);
if(it==2|| 0!=(where&8192) && it==4) continue;
}

final boolean[]bb=0!=(where&4096)?resSelPosDisplayed(s):  s.getSelectedAminoacids();
if(nxtTrue(bb,0,0x7fffffff)<0) continue;
final int off=s.getSelectedAminoacidsOffset()-firstResIdx(this),n=min(nR,min(bb.length+off,aTo));
for(int i=Math.max(off,aFrom);i<n;i++){
if(bb[i-off]){
if(v==null) return true;
found=true;
v.add(s);
break;
}
}
}
return found;
}

public Map residueAnnotationsByGroup(){
final Object[]cached=cached();
final ResidueAnnotation[]aa=residueAnnotations();
ChMap mGrps=(ChMap)cached[14];
if(cacheEmpty(cached,14,_vv==null?0:MC[37]+modic(_vv[9])+modic(_vv[10])+modic(_vv[14])) || mGrps==null){
if(mGrps==null){


runCR1(207,runCR1(1292,cached[14]=mGrps=new ChMap(0,String.class,UniqueList.class,16),"attach"),"Residue Annotations");
}
clr(mGrps.vArray());
for(ResidueAnnotation a:aa){
if(a.featureName()==null){
final String group=a.value(2);
UniqueList<ResidueAnnotation>v=(UniqueList)mGrps.get(group);
if(v==null) mGrps.put(group,runCR1(207,v=new UniqueList(39),group));
runCR1(1292,v,"attach");
v.add(a);
}
}
for(Object v:mGrps.vArray()) if(szeVA(v)<=0) mGrps.remove(getTxt(v));
for(int i=2;--i>=0;){
final List v=vChilds(-i==0?14:10);
if(sze(v)>2) sortArry(v,chUtils(52));
}
}
return mGrps;
}




public void addInvalidFeatureHC(long hc){
synchronized(alias(64)){
if(!isInvalidFeatureHC(hc)){
if(_iFtr==null||_iFtrCount>=_iFtr.length) _iFtr=chSze(_iFtr,_iFtrCount*2+10);
_iFtr[_iFtrCount++]=hc;
}
}
}
public boolean isInvalidFeatureHC(long hc){
synchronized(alias(64)){
for(int i=_iFtrCount;--i>=0;) if(_iFtr[i]==hc) return true;
return false;
}
}




public Object run(int id,Object arg){

int returnWords=-1;
switch(id){

case 1505:{
final Protein[]pp=spp(sobjectsOfType(4,selValues(arg),null));
if(pp.length>0 && dlgYesNo(sobjectsTitle(pp,toBA("Delete ")).a('?'))) rmFromProt(pp,this);
break;
}
case 718:{
Object ic=_icon;
if(ic==null){
final BA d64=iconBase64();
if(sze(d64)>0) _icon=ic=runCR(819,mkInstance(0x40000000,iClass(26)),s(d64),null);
if(ic==null){
final String url=iconURL();
if(sze(url)>0){
_icon="";
imgRequest(url,this);
}
}
}
return ic==""?null:ic;
}
case 1277:{
final BA sb=baClr(159);
final int aFL=xatoi(arg)+subsetStart();
if(xatoi(arg)<0 || xatoi(arg)>=countRes()) return sb.a("error");
if(!onlyActgn() && 0==(INTS[4]&1)) sb.aBytesAdj(getResName32At(xatoi(arg)),4);
sb.a(" Index ").a(firstResIdx(this)+xatoi(arg)+1);
if(getChain()!=null) resnAsText(0,xatoi(arg),sb.a(" Residue "));
if(!Float.isNaN(iThFloat(3*aFL,getResidueCalphaCurrent()))) sb.a(" xyz ");
switch(iThByte(aFL,getResidueSecStrType())){
case'H':sb.a("  Helix (red)");break;
case'E':sb.a("  Beta sheet (yellow)");break;
}
{
final int ft=iThInt(aFL,_resAtomIdx),f=ft>>>8,t=f+(ft&0xFF);
if(ft!=-1 && t>f) sb.a("  Atom ").aFromDashTo(f+1,t);
}
final byte[]triplets=triplets();
if(sze(triplets)>3*xatoi(arg)+2){
final int nt=3*aFL;
if(hasExons()){
final int ex0=exonForAminoZ(xatoi(arg),0),ex2=exonForAminoZ(xatoi(arg),2);
sb.a(" Exon ").a(1+ex0);
if(ex0!=ex2) sb.a(',').a(ex2+1);
}
sb.a(" Triplet ").aFT(triplets,nt,nt+3).a(' ');
for(int t=0,last=-0x80000000;t<3;t++){
final int n=aa2ntZ(xatoi(arg),t);
final char plus1=n-last==1?'+':last-n==1?'-':' ';
if(plus1==' ') sb.a(n+1+getIntProperty(15)); else sb.a(plus1).a('1');
sb.a(' ');
last=n;
}
}
return  sb;
}
case 1170:{
final Object[]cached=cached();
String s=(String)fromCache(cached,20,mc((22<<6)|2)+mc((26<<6)|6));
if(s==null){
final BA sb=baClr(159).a(this);
if(isTranslated()) sb.a(' ').aBytes(isReverseComplement()?('R'|('C'<<8)):'F');
cached[20]=s=sb.and("  (",getPdbID(4),")").toString();
}
return  s;
}
case 539: _rendMC[0]=HASH_CODE32+mc((6<<6)|5);return _rendMC;

case 1248:{
final ChButton c=new ChButton((8192|32768|16384),null,null);
setProt(this,setBG(0xFFffFF,
updateOn(4,
updateOn(2,addLi(null,(1<<3)|(1<<1)|(1<<19),pcp(1520|0x40000|0x80000|65536,_main,c))))));
c.setFont(getFnt(c).deriveFont(1));
setProt(this,c);
return awtc(28,
setMaxSze(999,999,
pcp(1261,_main,
pcp(213,_main,
pcp(487,"",
pcp(195,io(xatoi(arg)|8),
awtc(32768,setTip(_main,c))))))));

}
case 1168:{
final int i01=0!=(xatoi(arg)&4)?1:0;
Object c=_pLabel[i01];
if(c==null)_pLabel[i01]=c=runCR1(1248,this,arg);
setProt(this,setBG(0xFFffFF,c));
return  c;
}
case 1166:{
if(arg=="") return "";
final Object ic=runCR(718,this);
return  img(ic!=null?ic: hasCalpha(this) && 1!=INTS[5]?"Peptide_filled": isTranslated()?"dna_helix":null);
}
case 554: return getName();
case 836:{
final int dOpts=dragOptions();
fileOfProteinForDir(5,null,iFile(53));
fileOfProteinForDir(2,null,iFile(53));

final boolean
writeSingleFA=(_flags&4)!=0 && (dOpts&1)==0 || getFile()==null,
writeAllPdbChains=hasCalpha(this) && (dOpts&2)!=0 && sze(xiThEl(1,chainsByType()))>1;

getAtomXYZ();

if(_mapDragfileModi==null) _mapDragfileModi=new HashMap();
final String mcOpts=s(new BA(99).a(mc((8<<6)|20)).a('_').a(dOpts)),base,ext;
{
final String name=getName(),sfx=delIdx(0x40000|0x20000|'.',name),bas=delIdx(0x2000000|'.',name);
boolean success=false;
if(sze(sfx)>0){
success=2*sze(sfx)<sze(bas);
for(String s:custSettings(1750)) success=success || chrAt(strstr(65536,sfx,s,0,0x7fffffff),s)==' ';
}
base=success?bas:name;
ext=success?sfx:"";
}
final Collection<File>v=new ArrayList();
int countB=0;
final Matrix3D[]mmDrag=new Matrix3D[getAssemblyMatrices(this).length];
for(Matrix3D m:getAssemblyMatrices(this)) if(m!=null && m._assemblyID==((dOpts>>>8)&255)) mmDrag[countB++]=m;
cpy(fileOfProteinForDir(6,this,null),fileOfProteinForDir(6,this,iFile(53)));
cpy(fileOfProteinForDir(9,this,null),fileOfProteinForDir(9,this,iFile(53)));
if(countB==0 && !writeAllPdbChains) save(iFile(53),new BA(333),null);
if(countB>0){
getAtomXYZ();
final Collection vTxt=new ArrayList();
for(int m=mmDrag.length;--m>=0;){
if(mmDrag[m]!=null){
final File fB=file(iPath2(53,base).a(".biomol_").a(((dOpts>>>8)&255)).a('_').an('0',m<10?1:0).a(m).a(".pdb"));
if(sze(fB)==0 || !mcOpts.equals(_mapDragfileModi.get(fB))){
wrte(fB,strapInstance(15).getProteinText((16|1024|64|128|4),this,new Matrix3D[]{mmDrag[m]},null,clr(vTxt)));
}
v.add(fB);
}
}
final File fB=file(iPath2(53,base).a(".biomol_").a(((dOpts>>>8)&255)).a("_ALL.pdb"));
if(sze(fB)==0 || !mcOpts.equals(_mapDragfileModi.get(fB))){
try{
final OutputStream fo=fOutStrm(0,fB);
wrteOS(fo,strapInstance(15).getProteinText(16|1024,this,null,null,clr(vTxt)));
for(int i=0;i<mmDrag.length;i++){
if(mmDrag[i]!=null) wrteOS(fo,strapInstance(15).getProteinText((16|1024|64|128|4),this,new Matrix3D[]{mmDrag[i]},null,clr(vTxt)));
}
closeStrm(fo);
v.add(fB);
}catch(IOException iox){errorEx(iox,"RUN_PROVIDE_DND_FILES",fB);}
}
}else{
File fExpr=null;
BA sbHeteros=null;
File fOut=newFile(iFile(53),
INTS[12]==4?new BA(99).a("dnd_het_").a(nam(this)).a('_').a(resnAt(0,0)).a('_').a(getChain()).del("_\0").a('_').aHex(hashCdFloats(getAtomXYZ(),0,0x7fffffff)).a(".pdb"):
(dOpts&1)!=0 && getFile()!=null?nam(getFile()): new BA(99).a(base).a(writeAllPdbChains?"_all":"").a(writeSingleFA?".fa":ext));
if(!mcOpts.equals(_mapDragfileModi.get(fOut))) fileDel(0,fOut);
if(writeAllPdbChains){
final Matrix3D m3d=getRotationAndTranslation();
if((dOpts&4)!=0 || isUnitOrNull(m3d))  v.add(getFile());
else{
if(sze(fOut)==0){
final int save=seqParserOptions(0);
final Protein[]pp=proteinsAllChains(0);
for(int i=pp.length;--i>=0;)pp[i].setRotationAndTranslation(m3d);
fOut=pdbFileWrite(256|(2|16|1024|64|128),pp);
seqParserOptions(save);
}
v.add(fOut);
}
}else if(writeSingleFA){
if(sze(fOut)==0){
final BA sb=baClr(159).a('>').a(this).a('|');
final String[]ss=getRefs(0);
for(int i=0;i<ss.length;i++) sb.a(i==0?" refs=":null).a(ss[i]).a(',');
if(firstResIdx(this)>0) sb.a(" FIRSTINDEX=").a(firstResIdx(this)+1);
wrte(fOut,sb.aln().aln(getResType()));
}
v.add(fExpr=fOut);
}else{
if(INTS[12]==4||
(dOpts&4)==0 && getResidueCalphaXYZ(null)!=null && !isUnitOrNull(getRotationAndTranslation())){

if(sze(fOut)==0) wrte(fOut,strapInstance(15).getProteinText(256|(16|1024|64|128|4),this,new Matrix3D[]{getRotationAndTranslation()},null,null));
v.add(fOut);
if(INTS[12]==1) fExpr=fOut;
}else{
v.add(fExpr=getFile());
for(Protein h:getMolecules(6)){
if(h.getFile()!=null){
if(sbHeteros==null) sbHeteros=new BA(333).aln(getName());
sbHeteros.a(h.getFile()).a(' ');
}
}
}
}
if(fExpr!=null) wrte(file(iPath2((53|(248<<16)),fExpr.getName())),sbHeteros!=null?sbHeteros:getName());
}
while(v.remove(null)){}
final File[]ff=toArryClr(v,NO_File);
for(File f:ff) _mapDragfileModi.put(f,mcOpts);
return ff;
}




case 1561: updateChildTreeP(vChilds(-15),null,this);break;
case 555:{
final Object[]cached=cached();
final ChMap grouped=(ChMap)residueAnnotationsByGroup();
Object[]cc=(Object[])fromCache(cached,21,(_vv==null?0: modic(_vv[11])+modic(_vv[15])+modic(_vv[6]))+MC[37]+MC[34]);
if(cc==null){
Object[]buf=(Object[])cached[22];
if(buf==null) cached[22]=buf=new Object[7];
buf[0]=vChilds(MC[34]==0?8: 13);
buf[1]=vChilds(-15);
buf[2]=grouped.vArray().length>0?grouped:null;
buf[3]=vChilds(-10);
buf[4]=vChilds(-14);
buf[5]=vChilds(-4);
buf[6]=vChilds(-7);
for(int i=buf.length;--i>=0;) if(sze(buf[i])==0) buf[i]=null;
cached[21]=cc=rmNullA(buf);
}
return cc;
}
case 205:{
Object ic=runCR(718,this);
if(ic==null||img(ic)!=arg){
if(ic==null) _icon=ic=img2ic(arg);
strapIncMC(6,this);
strapEvtDispatch(22|(1<<8)*333);
}
break;
}
case 559: return _strgMatchType==2?residueAnnotations():null;
case 560: returnWords=_strgMatchType;break;
case 561: returnWords=0x7fffffff;break;
case 1183:{
if(arg==null && evtId(arg=_X[101])!=(3+500)) arg=null;
if(x(arg)>Math.max(9,INTS[7])) return balloonText(0);
final BA sb=baClr(159);
if(getColrO(this)!=null) sb.colorBar(rgba(getColrO(this),0xFFffFF));
sb.aFile(16,getFile()).htmlBR();
{
Object icon=base64ToFile(iconBase64());
if(sze(icon)==0){
final String u=iconURL();
if(sze(icon=file(u))==0) icon=u;
}
if(icon!=null){
sb.a("<IMG src=\"").a(url(icon)).a("\"><BR>");
if(0!=(1&evtModi(arg))) return sb;
}
}
runCR1(1460,this,sb);
if((_flags&4)!=0) sb.aFile(getFile()).aln();
{
final String acc=seqId(5);
sb.and(" Acc=",acc);
if(getRefs(0).length>0){
int count=0;
for(String r:getRefs(0)){
if(!eq(r,acc)){
if(count++==0) sb.a(" IDs: ");
sb.a(count%6==0?'\n': ' ').a(r);
}
}
}
}
sb.htmlBR().a(balloonText(2)).htmlBR();
if(isTranslated()) sb.htmlBR().a(isReverseComplement()?"Reverse-Complement":"Forward");
{
final String[]unip=getRefs(1);
if(!(unip==null||unip.length==0)){
sb.htmlBR().a("By sequ identity:");
for(String s:unip) sb.a(' ').aWithoutPfx("UNIPROT:",s);
sb.htmlBR();
}
}
if(!Float.isNaN(_resolution)) sb.htmlBR().a("Resolution ").a(_resolution).a(" Angstrom<BR>");
{
final int i0=firstResIdx(this);
if(i0>0) sb.htmlBR().a(i0+1).an('.',3).a(i0+subsetEnd()-subsetStart()).htmlBR();
}
Protein[]hh;
if((hh=getMolecules(7)).length>0){
sobjectsTitle(hh,sb.colorBar(0x00FF00)).a(" &nbsp; ");
for(Protein nuc:hh) nuc.appendNucColonChain(sb.a(' '));
sb.htmlBR();
}
if((hh=getMolecules(4)).length>0){
sb.colorBar(0xFF0000);
int sbL0=sze(sb);
sobjectsTitle(hh,sb).a(" &nbsp; ");
for(Protein h:hh){
sb.a(' ').a(h.getNameForPymol());
if(sze(sb)-sbL0>60) sbL0=sze(sb.htmlBR());
}
sb.htmlBR();
}
return  sb.del("<BR>");
}

case 734: return getName();
case 1278:{
runCR1(1460,this,((BA)arg));
final String tt=balloonText(2);
if(sze(tt)>0) ((BA)arg).htmlBR().a(tt);
final String pdb=getPdbID(4);
if(pdb!=null) ((BA)arg).htmlBR().a(pdb).a(" identity: ").a((int)(_infXYZMatch>>>32)).a(" of ").a((int)(_infXYZMatch&0xffFFffFFL));
return ((BA)arg);
}
case 547:{
if(!eq(_color,_color=arg)){
strapIncMC(6,this);
for(View3d v:get3dViews()) v3dUpdateRibbons(-2,v);
}
return  "";
}
case 709: return _color;
case 1279:{
int count=0;
final BA sb=((BA)arg).aln("<UL>");
{
final String acc=seqId(5),uid=seqId(0),pid=getPdbID(2);
if(acc!=null && !acc.equals(pid)) sb.and("<LI>Accession: ",acc).aln("</LI>");
if(pid!=null) sb.a("<LI>").aWithoutLstCmpnt('_',pid).a(" Chain ").aLstCmpnt('_',pid).aln("</LI>");
if(uid!=null && !uid.equals(acc)) sb.and("<LI>",uid).aln("</LI>");
for(int j=3;--j>=0;){
if(j!=0&&j!=1) continue;
for(String r:getRefs(j)) if(!r.equals(acc)&&!r.equals(uid)&&!r.equals(pid)) sb.a(count++>0?null:j==0?"<LI>References: ":"<LI>By sequence identity: ").a(r).a(' ');
if(count>0) sb.aln("</LI>");
}
}
for(int j=3;--j>=0;){
count=0;
final int t=j==0?2:j==1?3:4;
for(Protein h:getMolecules(t)){
if(count++==0) sb.a("<LI>").a(iConst(1927,t)).a(' ');
sb.a(t==4?h.getName():h.getChain()).a(' ');
if(count>0) sb.aln("</LI>");
}
}
sb.a("</UL>").del("<UL>\n</UL>").aln().and(getProperty(7),"<BR>");
break;
}
case 1460:{
final BA sb=((BA)arg);

final Object c=orO(getProperty(5),getProperty(4));
if(sze(getProperty(1))>0){
final int L=sb.end();
sb.aFilter(8192,getProperty(1)).replace(0,"|","<BR>",L,0x7fffffff).htmlBR();
}
final Object o=getProperty(2),sc=getProperty(3);
sb.aFilter(8192,c).htmlBR().aFilter(8192,sc).htmlBR();
if(sze(o)>0 && !o.equals(sc)) sb.aFilter(8192,o).htmlBR();
break;
}
}

if(returnWords>=0){
if(returnWords==2) return resSel(11);
if(returnWords==3) return getResTypeSUC();
Arrays.fill(HAYSTACKS1,null);
int i=0;
if(returnWords==0||returnWords==0x7fffffff)  HAYSTACKS1[i++]=getName();
if(returnWords==1||returnWords==0x7fffffff){
for(;i<15;i++) HAYSTACKS1[i]=seqData(i);
HAYSTACKS1[i++]=getPdbID(2);
HAYSTACKS1[i++]=getProperty(1);
HAYSTACKS1[i++]=getRefs(0);
}
return HAYSTACKS1;
}

return null;
}
public Protein[]proteinsAllChains(int opt){
String[]chains=(String[])xiThEl(1,chainsByType()),cc=null;
for(int i=sze(chains);--i>=0;){
if(chains[i]!=null && !chains[i].equals(getChain())){
if(cc==null) cc=new String[i+1];
cc[i]=chains[i];
}
}
return cc==null?spp(this): adToArry(0,this,readAddToPep(null,readPepOrNuc(opt==0?0x800000:opt,cc,getFile())),Protein.class);
}






public void toXML(int opt,BA sb,String cacheKey){
final Collection vSel=vNoClr(240|0x40000);
final boolean selected=cntainsEl(this,vSel);
final String UM=" unmodified=\"true\" />\n";
final int mc[],nR=countRes();
if(cacheKey!=null && (0!=(opt&(1<<10))||0!=(opt&(1<<12)))){
if(_serverMC==null) _serverMC=new HashMap();
final int[]mc0=0!=(opt&(1<<12))?null:(int[])_serverMC.get(cacheKey);
_serverMC.put(cacheKey,MC.clone());
mc=mc0!=null && MC[6]==mc0[6]?mc0:null;

}else mc=null;
sb.a("\n<protein name=\"").a(this).a("\" file=\"").a(getFile());
if(selected) sb.a("\" selected=\"true");
sb.aln("\" >");
if(firstResIdx(this)!=0) sb.a("<residueIndex1>").a(firstResIdx(this)+1).a("</residueIndex1>\n");
sb.a("<sequence");
if(mc!=null && mc[8]==MC[8]) sb.a(UM);
else sb.a('>').a0(getResType()).aln("</sequence>");
if(getResColumn().length>=nR){
sb.a("<alignmentColumns");
if(mc!=null && mc[13]==MC[13]) sb.a(UM);
else{
final int pos=sb.end();
final byte[]T=seriesToTextN(1,getResColumn(),nR,1,1,1,sb.a('>')).aln("\n</alignmentColumns>").bytes();
if(T[pos]=='1' && T[pos+1]==' ') T[pos]=' ';
}
}
if(countNucleotides()>0){
sb.a("<codingSequence");
if(mc!=null && mc[26]==MC[26]) sb.a(UM);
else sb.a('>').a0(triplets()).aln("</codingSequence>");
}
if(getPdbID(4)!=null&&_infXYZMatch!=0) sb.a("<inferredStructure pdbID=\"").a(getPdbID(4)).a("\" match=\"").a((int)(_infXYZMatch>>>32)).a('/').a((int)(_infXYZMatch&0xffFFffFFL)).aln("\" />");
for(int i=3;--i>=0;){



final String id=i==0?getPdbID(2): seqId(i==1?0:5),t=iConst(2226,i);
if(id!=null) sb.a('<').a(t).a('>').a(id).a("</").a(t).a('>').aln();
}
if(getResidueSecStrType()!=null){
sb.a("<secondaryStructure");
if(mc!=null && mc[14]==MC[14]) sb.a(UM);
else{
toSeries(2,0,0x7fffffff,sb.a('>').aln());
sb.aln("\n</secondaryStructure>");
}
}
{
int e0=sb.end();
if(resnToSeries(0,sb.aln("<residueNumber>"))) sb.a("\n</residueNumber>"); else sb.setEnd(e0);
e0=sb.end();
if(toSeries(1,0,0x7fffffff,sb.aln("<residueInsertionCode>"))) sb.aln("\n</residueInsertionCode>"); else sb.setEnd(e0);
}
sb.and("<chainChar>",getChain(),"\n</chainChar>\n");
{
final ResidueSelection[]ss=resSel(11);
if(ss.length>0){
sb.a("<residueSelections");
if(mc!=null && mc[33]==MC[33]) sb.a(UM);
else{
sb.a('>');
for(ResidueSelection s:ss){
sb.a1('\n').a("<residueSelection name=\"").a(nam(s)).a("\" aa=\"").boolToText(s.getSelectedAminoacids(),s.getSelectedAminoacidsOffset()+1," ","-");
if(cntainsEl(s,vSel)) sb.a("\" selected=\"true");
sb.a("\" ");
if(sobjectType(s)==9){
sb.aln(">\n<data>");
for(ResidueAnnotation.Entry e:((ResidueAnnotation)s).entries()) if(e.isEnabled()) sb.a(e.key()).a1(' ').aFilter(8192,e.value()).aln();
sb.aln("</data>\n</residueSelection>");
}else sb.aln(" />");
}
sb.aln("</residueSelections>");
}
}
}
if(!isUnitOrNull(getRotationAndTranslation())){
sb.a("<transformation3D");
if(mc!=null && mc[18]==MC[18]) sb.a(UM);
else getRotationAndTranslation().toText(5,null,sb.a('>')).aln("</transformation3D>");
}
if(hasCalpha(this)){


final boolean atoms=0!=(opt&(1<<3)) || selected&& 0!=(opt&(1<<4));

if(0!=(opt&(1<<5)) || selected&& 0!=(opt&(1<<6)) || atoms){
sb.a("<pdbFormat");
if(mc!=null && mc[atoms?20:19]==MC[atoms?20:19]) sb.a(UM);
else sb.aBytes('>'|('\n'<<8)).join(0,strapInstance(15).getProteinText(atoms?(16|1024|64|128|4):(16|1024|2),this,null,null,null)).aln("</pdbFormat>");
}
}
if(sze(getFile())>0 && (_flags&4)==0 && (0!=(opt&(1<<7)) || 0!=(opt&(1<<9)) && 0!=(opt&(1<<8)))){
sb.a("<fileContent>");
if(mc!=null && mc[1]==MC[1]) sb.a(UM);
else sb.a('>').aln().aFilter(8192,readBytes(getFile())).aln("</fileContent>");
}
sb.aln("</protein>\n");
}
















private static boolean[]_cClasName;
public Object rplcVars(boolean spc2us,String txt){
Object s=txt;
final String[]vv=arry(2043);
if(strchr('$',s,0,0x7fffffff)>=0){
if(strstr(0,vv[1],s,0,0x7fffffff)>=0){
final Object osc=getProperty(3);
int spc=strchr(' ',osc,0,0x7fffffff);
if(0<spc || 0<(spc=strchr('_',osc,0,0x7fffffff))) s=strplc(0,vv[1],new BA(99).aFT(osc,0,1).a('_').aFT(osc,spc+1,0x7fffffff),s,0,0x7fffffff);
}
if(strstr(0,vv[2],s,0,0x7fffffff)>=0){
final String[]cds=getCDS(INTS[10]);
if(cds!=null){
s=strplc(0,vv[2],orS(cds[1],"_"),strplc(0,vv[3],orS(cds[2],cds[3],"_"),s,0,0x7fffffff),0,0x7fffffff);


}
}
s=strplc(0,vv[12],getName(),strplc(0,vv[11],orS(delIdx(0x80000|':',seqId(0)),"_"),strplc(0,vv[10],orS(delIdx(0x80000|':',getPdbID(2)),"_"),strplc(0,vv[9],orS(delIdx(0x80000|':',seqId(5)),"_"),strplc(0,vv[8],orS(seqId(3),"_"),strplc(0,vv[7],orS(getChain(),"_"),strplc(0,vv[6],orS(getProperty(2),"_"),strplc(0,vv[5],orS(getProperty(3),getProperty(2),"_"),strplc(0,vv[4],orS(getOrganism5(),"_"),s,0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff),0,0x7fffffff);

}
if(spc2us && s!=null){
if(_cClasName==null) (_cClasName=chrClas(-129).clone())['!']=false;
s=toBA(s).replaceCC(_cClasName,(byte)'_',0,0x7fffffff);
}
return s;
}



public boolean hasExons(){
final int mt=INTS[4];
return exons()!=null && strapAlignmentType()!='C' && (mt==0 || 0!=(mt&1) && 0==(mt&2));
}
public void setMoleculeType(byte[]T,int b,int e){
for(int i=43;--i>=0;) if(strstr((4096|8192),iConst(1923,i),T,b,e)>0) setIntProperty(4,i);
}





public boolean complies(int what){
boolean e=true;
if((what&256)!=0 && !onlyActgn())e=false;
else if((what&4)!=0 && !hasCalpha(this))e=false;
else if((what&8)!=0 && isUnitOrNull(getRotationAndTranslation()))e=false;
else if((what&32)!=0 && sze(OBJECTS[20])==0)e=false;
else if((what&0x20000)!=0 && getPdbID(4)==null)e=false;
else if((what&4096)!=0 && get3dViews().length==0)e=false;
else if((what&64)!=0 && (_flags&64)==0)e=false;
else if((what&1024)!=0 && onlyActgn())e=false;
else if((what&128)!=0 && (_flags&64)!=0)e=false;
else if((what&0x40000)!=0 && isLoadedFromStructureFile())e=false;
else if((what&2048)!=0 && hasCalpha(this))e=false;
else if((what&0x80000)!=0 && getPdbID(2)!=null)e=false;
else if((what&2)!=0 && !isTranslated())e=false;
else if((what&512)!=0 && !isTranslated() && !onlyActgn())e=false;
else if((what&16)!=0 && getPdbID(2)==null)e=false;
else if((what&8192)!=0 && getResidueSecStrType()==null)e=false;
else if((what&16384)!=0 && getResidueAccessibility1(0)==null)e=false;
else if((what&0x100000)!=0 && (_infXYZMatch==0||  (_infXYZMatch>>>32)==(_infXYZMatch&0xffFFffFFL)))e=false;
else if((what&0x1000000)!=0 && countCDS()==0)e=false;

else{

if(_vv!=null){
if((what&0x400000)!=0 && sze(_vv[11])==0)e=false;
else if((what&0x200000)!=0 && sze(_vv[9])==0)e=false;
else if((what&0x800000)!=0 && sze(_vv[10])==0)e=false;
}

}
if(e && (what&32768)!=0 && getMolecules(4).length==0)e=false;
if(e && (what&65536)!=0 && getMolecules(7).length==0)e=false;
return e;
}




static boolean _refseqDownloading;

private final class ReferenceSequence extends Thread{
final Object _p,_files[];
final Protein _pRef;
final String _id;
java.net.URL _url;
short[]_u2i;
boolean _downloaded;
int _mc;

ReferenceSequence(String id,Protein p){
_id=id;
_p=wref(p);
final Object[]ff=_files=new Object[2];
_pRef=null;
{
ff[0]=dbfetchDbColonID2file(id);
ff[1]=file(hrefToUrlString(2,id));
}
if(sze(ff[0])+sze(ff[1])==0){
_url=url((hrefToUrlString(2,id)));
adUniq(this,vNoClr(364|0x20000));
if(!_refseqDownloading) startThrd(this);
;
}
if(sze(ff[0])+sze(ff[1])>0) _downloaded=true;
}



short[]u2i(){
final Protein pu=_downloaded?refP():null,p=sp(_p);
if(pu==null||p==null) return null;
final byte[]aaU=pu.getResType(),aa=p.getResType();
if(aaU.length*aa.length==0) return null;
short[]u2i=_u2i;
if(_mc!=(_mc=pu.mc(8)+p.mc(8)) || u2i==null && !(aaU==null||aaU.length==0)){
byte[][]aligned=gappedForPerfectMatch(aa,aaU);
if(null==aligned && null==(aligned=smithWaterman(aa,aaU,null))) return null;
final byte[]a0=aligned[0],a1=aligned[1];
if(a0!=null && a1!=null){
;
;
java.util.Arrays.fill(_u2i=u2i=new short[aaU.length],(short)-1);
short idxO=(short)idxOfLetters(a0,aa,0,0x7fffffff);
short idxU=(short)idxOfLetters(a1,aaU,0,0x7fffffff);
final int TO=mini(a0.length,a1.length);
for(int c=0;c<TO;c++){
final boolean lO=isChrClas(133,a0,c),lU=isChrClas(133,a1,c);
if(lO && lU && 0<=idxU && idxU<u2i.length) u2i[idxU]=idxO;
if(lO) idxO++;
if(lU) idxU++;
}
}
}
return u2i;
}




public void run(){
synchronized(recordSync(vNoClr(364|0x20000),"_refseqDownloadV")){
_refseqDownloading=true;
for(int n; (n=sze(vNoClr(364|0x20000)))>0;){
for(int i=n;--i>=0;){
final ReferenceSequence rs=(ReferenceSequence)xiThEl(i,vNoClr(364|0x20000));
if(rs!=null){
dlUrl(rs._url);
rs._downloaded=true;
final Protein p=sp(_p);
if(rs.refP()!=null && p!=null){
strapIncMC(33,p);
strapIncMC(35,p);
strapEvtDispatch(29|(1<<8)*333);
}
}
vNoClr(364|0x20000).remove(rs);
}
sleepMS(10);
}
_refseqDownloading=false;
}
}




Protein refP(){
if(_pRef!=null) return _pRef;
final Map m=mapNoClr(0x40000000|156);
Protein p=(Protein)m.get(_id);
if(p==null){
for(Object f:_files){
if(sze(f)>0){
m.put(_id,p=newProteinInstance(0x100000|0x200000,readBytes(f)));
break;
}
}
}
return p;
}
boolean[]refIdx2Idx(boolean[]uniprot,int offset,int[]returnMinIdx){
final short[]u2i=u2i();
if(u2i==null) return NO_boolean;
final int offs=offset-firstResIdx(_pRef),N=mini(sze(u2i),uniprot.length+offs);
int min=0x7fffffff,max=-0x80000000;
for(int i=N;--i>=offs;){
if(uniprot[i-offs]){
final int idx=u2i[i];
if(idx<min) min=idx;
if(idx>max) max=idx;
}
}
if(min>max) return NO_boolean;
max=mini(min+99999,max);
final boolean[]bb=new boolean[max-min+1];
for(int i=N;--i>=offs;) if(uniprot[i-offs]) bb[u2i[i]-min]=true;
returnMinIdx[0]=min+firstResIdx(sp(_p));
return bb;
}

}


void parseXYZ(byte[]A,int L){
final int num=_siPrepareXYZ(A,L),nR=countRes();
if(num>0){
for(int i=3;i<_b90Tokens;i++){
final int f=TOKEN_FT[2*i],t=TOKEN_FT[1+2*i];
if(t-f>2 && A[f+1]=='='){
final int c0=A[f];
if((c0=='a'||c0=='e'||c0=='i')&&nR<=_siAminoIdx) return;
if(c0=='a'){
if(_atom32==null)_atom32=new int[nR][];
siParseArray32(A,f+2,t,_atom32[_siAminoIdx]=new int[num],null);
}else if(c0=='e'){
if(_elements==null)_elements=new short[nR][];
siParseArray32(A,f+2,t,null,_elements[_siAminoIdx]=new short[num]);
}else if(c0=='i'){
if(_resAtomNumOffsets==null) _resAtomNumOffsets=new int[nR][];
parseSeriesN(1,((ChTokenizer)xvClr(0x100000|339,169)).setText(A,f+2,t),_resAtomNumOffsets[_siAminoIdx]=new int[num]);
}else if(c0=='#'){
Arrays.fill(_atomXYZ=new float[3*(int)hexToLong(A,f+2,t)],Float.NaN);
_resAtomIdx=new int[nR];
_elements=new short[nR][];
_resAtomNum=new int[nR];
_flags|=16384;
strapIncMC(16,this);
_cache=null;clr(_serverMC);
_siAminoIdx=_siAtomIdx=0;
_siAtomSerial=1;
}else if(c0=='n'){
_siAtomSerial=(int)hexToLong(A,f+2,t);
}else if(c0=='I'){
_siAminoIdx=(int)hexToLong(A,f+2,t);
}else if(c0=='H'){
if(getIntProperty(12)!=4){
final String n=s(A,f+2,t);
for(Protein h:getMolecules(4)) if(n.equals(h.getName())) h.parseXYZ(A,L);
return;
}
}
}
}
if(nR<=_siAminoIdx) return;
if(_siAtomIdx*3<sze(_atomXYZ)) System.arraycopy(_siXyz,0,_atomXYZ,_siAtomIdx*3,num*3);
_resAtomIdx[_siAminoIdx]=_siAtomIdx;_siAtomIdx+=num;
_resAtomNum[_siAminoIdx++]=_siAtomSerial;_siAtomSerial+=num;

}
}
private static void siParseArray32(byte[]T,int f,int t,int[]destII,short[]destSS){
if(t<=f) return;
final boolean komma=T[f]==',';
for(int count=0,i=f+1,pos=f;i<=t;i++){
if(i==t || (komma?T[i]==',': (('A'<=T[i]&&T[i]<='Z')))){
final int v=komma?charsToBitsSkipSpc(T,pos+1,i-pos-1): charsToBitsSkipSpcUC(T,pos,i-pos);
if(destII!=null && destII.length>count) destII[count++]=v;
if(destSS!=null && destSS.length>count) destSS[count++]=(short)v;
pos=i;
}
}
}
private static int _b90Tokens;
private static int _siPrepareXYZ(byte[]A,int L){
if((_b90Tokens=tokns(' ',A,0,L,TOKEN_FT))<3){
baLog(16).a("Expected 3 base"+(127-33-3)+" blocks separated by space ").aFT(A,0,L).aln();
return 0;
}
final int f=TOKEN_FT[0],t=TOKEN_FT[5];
return xyz90FromText(_siXyz=redim(_siXyz,2*(t-f),99),1F/1000,A,f,t);
}


private static byte[]_base90;
static byte[]b90Charcodes(){
byte[]dd=_base90;
if(dd==null){
dd=_base90=new byte[(127-33-3)];
int count=0;
for(int i=33;i<127;i++) if(i!='~' && i!='-' && i!='>') dd[count++]=(byte)i;
;
}
return dd;
}
private static int[]_ascii90;
static int[]charcodeToBase90(){
int[]a90=_ascii90;
if(a90==null){
final byte[]digits=b90Charcodes();
a90=_ascii90=new int[128];
for(int i=digits.length;--i>=0;) a90[digits[i]]=i;
}
return a90;
}
private static int base90ToInt(byte[]T,int f,int t){
if(t-f<1) return 0;
int v=0;
for(int a90[]=charcodeToBase90(),i=T[f]=='-'?f+1:f;i<t;i++)v=v*(127-33-3)+a90[T[i]&127];
return T[f]=='-'?-v:v;
}
private static void intToBase90(int n,BA sb){
final byte[]digits=b90Charcodes();
if(n==0) sb.a((char)digits[0]);
int e=sb.end();
final byte[]T=sb.ensureCapacity(e+16);
if(n<0){T[e++]='-';n=-n;}
final int invertStart=e;
while(n!=0){
final int div=n/(127-33-3);
T[e++]=digits[n-div*(127-33-3)];
n=div;
}
sb.setEnd(e).invertText(invertStart,e);
}





static void xyzAddNans(float[]xyz,int f,int t){
if(t>0x7fffffff/3||(t*=3)>xyz.length)t=xyz.length;
for(int i=maxi(0,3*f);i<t;i++) if(Float.isNaN(xyz[i])) xyz[i-=i%3]=xyz[++i]=xyz[++i]=Float.NaN;
}
private static long xyzRangeNotNaN(float[]xyz,int f,int t){
xyzAddNans(xyz,f,t);
int b=-1,e=-1;
if(t>0x7fffffff/3||(t*=3)>xyz.length)t=xyz.length;
for(int i=maxi(0,3*f);i<t;i+=3){
if(!Float.isNaN(xyz[i])){
if(b==-1)b=i;
e=i;
}
}
return b==-1?0:((((long)(b))<<32)|(e+1));
}





public static void xyz90FloatToText(float[]xyz,float precision,int fromAtom,int toAtom,BA sb){
final byte[]digits=b90Charcodes();
if(toAtom>0x7fffffff/3||(toAtom*=3)>xyz.length)toAtom=xyz.length;
for(int i3=0;i3<3;i3++){
for(int a=i3+3*fromAtom;a<toAtom;){

while(a<toAtom && Float.isNaN(xyz[a])){a+=3; sb.a('~');}
if(a>=toAtom) break;
final int ori=(int)(precision*xyz[a]),min,to;
{
int t=a+3,mi=0x7fffffff,ma=-0x80000000,lst=ori;
for(;t<toAtom;t+=3){
if(Float.isNaN(xyz[t-i3])) continue;
final int abs=(int)(xyz[t]*precision),diff=abs-lst;
lst=abs;
final int miTmp=diff<mi?diff:mi;
if(diff>ma) ma=diff;
if(ma-miTmp>=(127-33-3)*(127-33-3)) break;
mi=miTmp;
}
min=mi;
to=t;
}
intToBase90(ori,sb);
sb.a('>');
if(a+3<to) intToBase90(min,sb);
sb.a('>');
if((a+=3)<to){
long lst=ori;
for(;a<to;a+=3){
if(Float.isNaN(xyz[a])) sb.a('~');
else{
final long abs=(long)(xyz[a]*precision),diff=abs-lst;
lst=abs;
final long v=diff-min;

;
final int hi=(int)(v/(127-33-3));
sb.a((char)digits[hi]).a((char)digits[(int)(v-hi*(127-33-3))]);

}
}
}
sb.a('>');
}
sb.del('>').a(' ');
}
}
public static int xyz90FromText(float[]xyz,float reciprocalPrecision,byte[]T,int fromPos,int toPos){
final int[]digits=charcodeToBase90();
if(xyz==null) return 0;
int i=0;
for(int i3=0,from=fromPos,to;i3<3;i3++,from=to+1){
to=strchr(' '|256,T,from,toPos);
i=i3;
for(int t=from;t<to;){
while(t<to&&T[t]=='~') {if(xyz.length>i) xyz[i]=Float.NaN; i+=3; t++;}
long v=0;
final long min;
{
final int oriB=t,oriE=strchr('>'|256,T,t+1,to);
t=strchr('>',T,oriE+1,to)+1;
if(i<xyz.length) xyz[i]=reciprocalPrecision * (v=base90ToInt(T,oriB,oriE));i+=3;
min=t<to?base90ToInt(T,oriE+1,t-1):0;

}
for(;t<to;i+=3){
final int b=T[t]&127;
if(b=='>') {t++;break;}
if(b=='~'){
if(xyz.length>i) xyz[i]=Float.NaN;
t++;
}else{

if(xyz.length>i) xyz[i]=reciprocalPrecision * (v+=min+(digits[b]*(127-33-3))+digits[T[t+1]&127]);
t+=2;
}
}
}

}
return i/3;
}



private static boolean isUcFirstAndNoLC(int n){
int b=n&255;
if(!(('A'<=b&&b<='Z'))) return false;
while((n>>>=8)!=0) if('a'<=(b=n&255) && b<='z') return false;
return true;
}
public Collection sequenceInStrapFormat(int opt,BA sb,Collection<byte[]>vTxt){
if(sb==null) sb=new BA(999);
if(vTxt==null && 0==(opt&0x80000)) vTxt=new ArrayList();
final int subsetEnd=subsetEnd(),nR=subsetEnd-subsetStart();
int count,e0=0;
Object v;
final byte[]rr=getResidueType();
final boolean hetero=getIntProperty(12)==4;
if(!hetero && 0==(opt&8)){
if(vTxt!=null) clr(sb);
if(subsetEnd-subsetStart()>0){
e0=sb.a("aa_sequence ").end();
final byte[]T=sb.ensureCapacity(e0+nR+6);
for(int i=subsetStart();i<subsetEnd;i++) T[e0++]=(byte)(residueHasXYZ(false,i)?(rr[i]&=~32): (rr[i]|32));
sb.setEnd(e0).aln();
}
e0=sb.end();
if(resnToSeries(0,sb.a("res_num "))) sb.aln(); else sb.setEnd(e0);
e0=sb.end();
if(toSeries(1,0,0x7fffffff,sb.a("res_insert "))) sb.aln(); else sb.setEnd(e0);
sb.and("chain ",getChain(),"\n");
{
final int[]nn32=getResidueName32();
if(nn32!=null){
count=0;
final int n=mini(subsetEnd,nn32.length,rr.length);
for(int i=subsetStart();i<n;i++){
final int n32=nn32[i];
if((n32!=0 && (n32&0xFFffFF)!=(toThreeLetterCode(rr[i])&0xFFffFF))){
if(count++==0) sb.a("res_name ");
sb.a((char)rr[i]).a(i-subsetStart()).a('=').aBytesAdj(n32,4);
}
}
if(count>0) sb.aln();
}
}
e0=sb.end();
{
final byte[]secStru=getResidueSecStrType();
final boolean[]lettr_digt_us=chrClas(139);
for(int L=sze(secStru)+1;--L>0;){
if(isChrClas(lettr_digt_us,secStru,L-1)){
sb.a("ss_91 ");
final byte[]chars=b90Charcodes();
for(int i=0,lastC=-0x80000000,lastI=0;i<=L;i++){
int c=i==L?0:secStru[i];
if(c<'0'||c>127||!lettr_digt_us[c]) c=0;
if(c!=lastC || i-lastI>=(127-33-3)-1){
if(i>0) sb.a((char)chars[i-lastI]).a(lastC==0?'-':(char)lastC);
lastC=c;
lastI=i;
}
}
sb.aln();
break;
}
}
}
for(int i=3;--i>=0;){
final Object txt=getProperty(i==0?5: i==1?4: 3);
if(sze(txt)>0) sb.a(i==0?"TI ": i==1?"DE ": "OS ").a(txt).aln();
}
if(sze(v=getProperty(20))>0) sb.a("EC ").join(' ',v).aln();
if((count=getIntProperty(8))!=0) sb.a("taxid ").a(count).aln();
{
final String acc=seqId(5);
if(acc!=null) sb.a("AC ").a(acc).aln();
count=0;
for(String s:getRefs(0)){
if(eqNz(acc,s)) continue;
if(count++==0) sb.a("xref ");
sb.a(s).a(' ');
}
if(count>0) sb.del(' ').aln();
}
{
final Protein[]hh=getMolecules(4);
if(hh.length>0){
sb.aln("# "+"\u001B[46m");
for(Protein h:hh)h._flags&=~256;
for(Protein h:hh){
if((h._flags&256)==0){
final int n32=h.getResidueName32()[0];
Object n=null;
sb.a("het ");
for(Protein h2:hh){
if(h2.getResidueName32()[0]==n32){
h2._flags|=256;
sb.a(h2).a(' ');
if(sze(n)==0) n=h2.getProperty(5);
}
}
sb.and("\"",n,"\"").aln();
}
}
sb.aln("# "+"\u001B[0m");
}

}
mkStrapScriptRessel(opt|64,sb);
}
float[]xyz;
if(!hetero && 0!=(opt&(2)) && (xyz=getResidueCalphaCurrent())!=null){
xyzAddNans(xyz,0,nR);
final long ft=xyzRangeNotNaN(xyz,subsetStart(),nR);
final int f=(int)(ft>>>32);
if(f>=0){
xyz90FloatToText(xyz,1000,f,(int)(ft&0xFFFFffffL),sb.a("\n"+"xyzCA "));
if(f!=0) sb.a1(' ').aHex(f);
sb.delBlanksR().aln().aln().bytesToCollection(vTxt);
}
}
if(!hetero){
sb.bytesToCollection(vTxt);
final Object[][]biomt=(Object[][])getProperty(26);
if(biomt!=null){
final Map<Object,Object>mapRefCount=new HashMap(),mapVarNames=new HashMap();
for(Object[]mol:biomt){
for(Matrix3D m3d:(Matrix3D[])mol[2]) mapRefCount.put(m3d,io(1+xatoi(mapRefCount.get(m3d))));
}
int varName=1;
final BA sbMx=baClr(107);
for(Object[]mol:biomt){
sbMx.a("biomt ").a(mol[0]).a(' ').join('|',mol[1]).a(' ');
for(Matrix3D m3d:(Matrix3D[])mol[2]){
if(xatoi(mapRefCount.get(m3d))>1){
Object var=mapVarNames.get(m3d);
if(var==null){
mapVarNames.put(m3d,var=io(varName++));
sb.a("let "+"$mx").a(var).a('=');
m3d.toText(3,null,sb).aln().bytesToCollection(vTxt);
}
sbMx.a(" $mx").a(mapVarNames.get(m3d));
}else{
m3d.toText(3,null,sbMx.a(' '));
}
}
sbMx.aln();
}
sb.aln().aln(sbMx).bytesToCollection(vTxt);
}
}
if(0!=(opt&4) && null!=(xyz=getAtomXYZ())){
final int[]atomF=getResidueAtomIdx(),rAtomNum=getResidueAtomNumber();
for(int amino=subsetStart(),initialized=0,aminoCount=-0x80000000,rAtomNumThis=1;amino<subsetEnd&&amino<atomF.length;amino++){
if(atomF[amino]<0) continue;
final short[]ee=getResidueElement(false,amino);
if(ee.length==0) continue;
xyzAddNans(xyz,0,0x7fffffff);
xyz90FloatToText(xyz,1000,atomF[amino],atomF[amino]+ee.length,sb.a("xyz "));

if(hetero) resnAsText(0,0,sb.aBytes('H'|('='<<8)).aBytes(getResidueName32()[0]).a('_')).a(' ');
if(initialized++==0) sb.aBytes('#'|('='<<8)).aHex(xyz.length/3).a(' ');
{
final int[]nn=getResidueAtomNumberOffsets(amino);
if(nn!=null) seriesToTextN(0,nn,nn.length,1,0,0,sb.aBytes('i'|('='<<8))).a(' ');
}
if(!hetero && amino!=aminoCount) sb.aBytes('I'|('='<<8)).aHexSgn(aminoCount=amino).a(' ');
{
final int[]aa=getResidueAtoms32(true,amino);
if(aa!=null){
sb.aBytes('a'|('='<<8));
boolean needKomma=false;
for(int a:aa) if(needKomma=!isUcFirstAndNoLC(a)) break;
for(int a:aa) if(needKomma) sb.a(',').aBytes(a); else sb.aUcfirst(a);
sb.a(' ');
}
if(getResidueElement(true,amino).length>0){
sb.aBytes('e'|('='<<8));
boolean needKomma=false;
for(short e:ee) if(needKomma=!isUcFirstAndNoLC(e)) break;
for(short e:ee) if(needKomma) sb.a(',').aBytes(e); else sb.aUcfirst(e);
sb.a(' ');
}

}
if(rAtomNum!=null&&rAtomNumThis!=rAtomNum[amino]) sb.aBytes('n'|('='<<8)).aHexSgn(rAtomNumThis=rAtomNum[amino]).a(' ');
rAtomNumThis+=ee.length;
aminoCount++;
sb.delBlanksR().aln().bytesToCollection(vTxt);
}
if(!hetero && 0!=(opt&64)){
final Protein[]hh=getMolecules(4);
if(hh.length>0){
sb.aln('#'+"\u001B[32m");
for(int i=0;i<hh.length;i++) hh[i].sequenceInStrapFormat(opt,sb,vTxt);
sb.aln('#'+"\u001B[0m");
}
}
}
sb.bytesToCollection(vTxt);
return vTxt;
}



static void mkStrapScript(int opt,Protein[]pp,BA temp,Collection<byte[]>vScript){
final int aliType=strapAlignmentType(),countVar[]={0};
final Map<String,String>mapVar=new HashMap();
int e0;
Object v;
if(aliType==41||aliType==43||aliType==62||aliType==42)  clr(temp).aln(iConst(2130,aliType));
for(Protein p:pp){
if(0==(opt&128) && (p._flags&64)==0) continue;
final int pos1=temp.a("let "+"$p=").aln(p).end(),pos2=temp.end();
{
final boolean needAA=p.exons()==null || !strEquAt(0x80000,p.getResType(),triplets2aa(true,p.triplets(),0x7fffffff),0,0x7fffffff);
if(p.exons()!=null){
temp.a("nt_sequence ");
if(!needAA) _mkStrapScriptGappedCDS(p,temp); else temp.a(p.triplets());
temp.a(',').and(" moleculeType=",iConst(1923,p.getIntProperty(4))," ");
Bitset.toText(p.exons(),p.isReverseComplement(),temp).aln(",$p");
}
if(needAA){
e0=temp.a(aliType==41||aliType==62?"nt_sequence ": aliType==42?"aa_sequence ": "sequence ").end();
temp.aFT(p.getGappedSequence(false),0,p.getResColumnMax()+1).replaceChar(' ','-',e0,0x7fffffff).aln(",$p");
}
}
if(p.getIntProperty(15)!=0) temp.a("set_nucleotide_index_offset ").a(p.getIntProperty(15)).aln(",$p");

if((v=getColrO(p))!=null) temp.a("color "+'#').aFT(v,0,8).aln(",$p");
{
final String pdb=p.getPdbID(2|4);
if(pdb!=null && p.isProteinStructure()){
if(p.getPdbID(2)!=null) temp.a("xref ").a(p.getPdbID(2)).a(",$p\n");
else temp.a("set_similar_pdb ").a(pdb).a(",$p\n");
if(0!=(opt&16)) temp.a("project_coordinates ").a(pdb).a(",$p\n");
}
e0=temp.end();
if(p.resnToSeries(0,temp.a("res_num "))) temp.aln(",$p"); else temp.setEnd(e0);
e0=temp.end();
if(p.toSeries(1,0,0x7fffffff,temp.a("res_insert "))) temp.aln(",$p"); else temp.setEnd(e0);
e0=temp.end();
if(p.aSecStru(temp.a("res_secstru "))) temp.aln(",$p"); else temp.setEnd(e0);
temp.and("chain ",p.getChain(),",$p\n");
if(p.getIntProperty(14)!=0) temp.a("set_residue_index_offset ").a(p.getIntProperty(14)).aln(",$p");
{
final String acc=p.seqId(5),rr[]=p.getRefs(0);
if(acc!=null && !acc.equals(pdb)) temp.a("AC ").a(acc).a(",$p\n");
final int end=temp.end();
boolean ok=false;
temp.a("xref ");
for(String r:rr) if(!r.equals(acc) && !r.equals(pdb)) {temp.a(r).a(' '); ok=true;}
if(ok) temp.aln(",$p"); else temp.setEnd(end);
}
}
if((v=getColrO(p))!=null) temp.a("color "+'#').a(v).a(",$p\n");
temp.a1('\n');
if(0==(opt&2)) p.mkStrapScriptRessel(opt,temp);
{
final Matrix3D m3d=p.getRotationAndTranslation();
if(!isUnitOrNull(m3d)) m3d.toText(0,null,temp.a("rotate_translate ")).aln(",$p");
if(0==(8&opt) && null!=(v=_mkStrapScriptVariable(orS(p.iconURL(),p.iconBase64()),temp,mapVar,countVar)))  temp.a("icon ").a(v).a(",$p\n");
for(String s:splitTkns('\n',p.balloonText(2))) temp.and("balloon_text ",s,",$p\n");
if(temp.end()==pos2) temp.setEnd(pos1);
else temp.a('\n');
}
{
Collection<String>vF=null;
int countH=0;
for(Protein h:p.getMolecules(6)){
if(h.getFile()!=null && p.getPdbID(2)!=null){
if(vF==null) (vF=new ArrayList()).add(s(p.getFile()));
if(adUniq(s(h.getFile()),vF)){
if(countH++==0) temp.a("het ");
temp.and("PDB:",pdbID(p.getPdbID(2))).and("_",h.getChain()).a(' ');
}
}
}
if(countH>0) temp.aln(",$p");
}
temp.bytesToCollection(vScript);
}
for(int i=0;i<2374;i++) if(SI_VALUES[i]!=null) temp.a(iConst(2130,i)).a(' ').aln(SI_VALUES[i]);
Strap.exportSequenceGroups(null,temp);
if(0!=(opt&256)){
temp.a('#').an('3',80).a('\n');
for(Map.Entry<String,Collection>e: entryArry(mapNoClr(221))){
temp.a("open_3D ").a(e.getKey()).a(',');
Collection recorded=null;
for(View3d v0:toArry(e.getValue(),View3d.NONE)){
final Protein p=sp(v0);
if(p!=null){
temp.a(0!=(p._flags&2)?p.getProperty(11): p).a(" ");
if(recorded==null) recorded=v3dRecordGeneric(null,v0);
}
}
temp.a('\n');
for(int i=0,R=sze(recorded);i<R;i++) temp.a(xiThEl(i,recorded)).a1('\n');
}
}
temp.bytesToCollection(vScript);
}
private void mkStrapScriptRessel(int opt,BA sb){
final Object[]selAA=(opt&4)==0?null:selectedResidueSelections(9);

for(ResidueAnnotation a:residueAnnotations()){


if(0==(opt&32) && (0==(a.getVisibleWhere()&(1<<7)) || a.isHiddenInHTML()) || nxtTrue(a.getSelectedAminoacids(),0,0x7fffffff)<0) continue;
if(((opt&4)==0 || cntainsEl(a,selAA)) && ((opt&64)!=0 || a.featureName()==null || 0!=(a._resanFlags&1))){
final String n=a.getName(),positions=resSelSimplifyPos(0,a);

sb.a("GFF ").an('|',2).a(n).a('|').a(positions).an('|',3).an('+',a.isAmino()?0:1).an('|',2);
final BA sbAnno=baClr(108);
for(ResidueAnnotation.Entry e:a.entries()){
final String v=e.value();
final int ki=e._ki;
if(ki==0||ki==1||ki==18||!e.isEnabled() ||v.indexOf("PAIR_ALIGNMENT:")>=0||
v.indexOf(" Alignment-Score=")>=0||
ki==7 && !isTrue(v)) continue;
final boolean variable=v.indexOf('$')>=0,spcOrVariable=variable || v.indexOf(' ')>=0;
if(spcOrVariable && v.indexOf('"')>=0){
sbAnno.a("add_annotation ").a(shrtClasNam(e.key())).an('\'',variable?1:0).a('=').an('\'',variable?1:0).a(v).an('\'',variable?1:0).aln(",~");
}else{
sb.a(e.key()).aBytes(spcOrVariable?('='|('"'<<8)):'=').a(v).aBytes(spcOrVariable?('"'|(' '<<8)):' ');
}
}
if(0!=(a._resanFlags&2)) sb.a("Color").aBytes('='|('#'<<8)).a(getColrO(a)).a(" ");
sb.aln().a(sbAnno);
}
}
}
private static void _mkStrapScriptGappedCDS(Protein p,BA sb){
final byte[]cds=p.triplets(),gg=p.getGappedSequence(false);
final int L=p.getResColumnMax()+1;
final boolean[]lettr=chrClas(133);
sb.ensureCapacity(sb.end()+cds.length+L);
for(int i=0,n=0;i<L;i++){
if(gg[i]==0) break;
if(iThBool(gg[i],lettr)){
if(cds.length>n+2) sb.a((char)cds[n]).a((char)cds[n+1]).a((char)cds[n+2]);
n+=3;
}else{
sb.a('-');
}
}
}
private static String _mkStrapScriptVariable(String data,BA sb,Map<String,String>mapVar,int[]count){
if(sze(data)==0) return null;
String v=mapVar.get(data);
if(v==null){
mapVar.put(data,v=new BA(10).a("$V").a(++count[0]).toString());
sb.a("let ").a(v).a('=').aln(data);
}
return v;
}


}

